(* ::Package:: *)

AppendTo[$Path,"/home/guanxin/mmapkg/external/LiteRed"];
AppendTo[$Path,"/home/guanxin/mmapkg/external/finiteflow-mathtools-master/packages"];
AppendTo[$Path,"/home/guanxin/mmapkg/external/finiteflow"];
AppendTo[$LibraryPath,"/usr/local/lib"];
If[$FrontEnd===Null,$InputFileName,NotebookFileName[]]//DirectoryName//SetDirectory;
<<LiteIBP.m;
<<topology.wl;


(*range of seeds*)
rank=3;
maxdots=1;


GetSectors["IBP"]:=NonZeroSectors[dbox];
GetSectors["LI"]=NonZeroSectors[dbox];
GetSectors["SR"]=UniqueSectors[dbox];
GetSectors["Map"]=MappedSectors[dbox];
GetSectors["ExtMap"]=If[TrueQ[#[[0]]==List],#,{}]&[ExtMappedSectors[dbox]];
GetSectors["OrtInt"]=Complement[LIBPUniqueSectorsNoEMs[dbox],LIBPUniqueUnmatchedSectorsMaybeNoEms[dbox]];
GetSeeds["IBP"][sector_]:=LIBPGenerateSeeds[sector,{0,maxdots},0,rank];
GetSeeds["LI"][sector_]:=LIBPGenerateSeeds[sector,{0,maxdots},0,rank];
GetSeeds["SR"][sector_]:=LIBPGenerateSeeds[sector,{0,0},0,rank];
GetSeeds["Map"][sector_]:=LIBPGenerateSeeds[sector,{0,maxdots+1},0,rank];
GetSeeds["ExtMap"][sector_]:=LIBPGenerateSeeds[sector,{0,maxdots+1},0,rank];


(*generate ibp identities*)
LIBPFastGenIds[dbox,GetSeeds,"Directory"->"ibps","LaunchKernels"->6,"GetSectors"->GetSectors];


(*preferred master integrals*)
exints = {};
Export["ibps/exints_def.m",exints];
Export["ibps/ids_dbox_exints.mx",(-#[[1]]+#[[2]])&/@exints,"MX"];
Export["ibps/ints_dbox_exints.mx",LIBPIntegralsIn[exints],"MX"];


(*transform identities to .JSON format*)
(*we keep s analytic to do self-consistent check*)
LIBPSerializeFastIds[FileNames["ibps/ids_dbox_*.mx"], {}, {s, t, eps}, "ExtraInts"->(First/@exints),"LaunchKernels"->6];


Quit[];
