(* ::Package:: *)

AppendTo[$Path,"/home/guanxin/mmapkg/external/LiteRed"];
AppendTo[$Path,"/home/guanxin/mmapkg/external/finiteflow-mathtools-master/packages"];
AppendTo[$Path,"/home/guanxin/mmapkg/external/finiteflow"];
AppendTo[$LibraryPath,"/usr/local/lib"];
If[$FrontEnd===Null,$InputFileName,NotebookFileName[]]//DirectoryName//SetDirectory;
<<LiteIBP.m;
<<topology.wl;


(*target integrals*)
target = {j[dbox,1,1,1,1,1,1,1,-3,0]};


exints = Import["ibps/exints_def.m"];
all = Join[LIBPGetAllInts[FileNames["ibps/ints_dbox_*.mx"]], First/@exints];
eqsfiles = FileNames["ibps/sids_*.json"];
vars = {t, eps};


(*collect infomation of the whole linear system into .JSON format*)
LIBPWriteSystemJSON[eqsfiles, all, target, vars, "FileName"->"system.json"];


FFNewGraph[graph,in,vars];

(* create a linear solver form system.json *)
FFAlgJSONSparseSolver[graph,ibps,{in},"system.json"];

(* don't include constant term in the (numerical) solution *)
FFSolverOnlyHomogeneous[graph,ibps];
FFGraphOutput[graph,ibps];


(* Learning phase: get the master integrals *)
ibplearn = FFSparseSolverLearn[graph,all];
{nonmis, mis} = {"DepVars", "IndepVars"}/.ibplearn;
Print["number of integrals" -> Length/@{nonmis,mis}];
mastersexpr = mis/.exints;


ibplearn


mastersexpr


(*trimming*)
FFSparseSolverMarkAndSweepEqs[graph,ibps];
FFSparseSolverDeleteUnneededEqs[graph,ibps];
Print["number of independent eqs."->FFSolverNIndepEqs[graph,ibps]];


(*reconstruction*)
sol = FFReconstructFunction[graph,vars,"MaxPrimes"->200,"MaxDegree"->1000];
sol = Partition[sol,Length@mis]//Factor


FFDeleteGraph[graph];
