(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    157072,       4066]
NotebookOptionsPosition[    143729,       3830]
NotebookOutlinePosition[    144074,       3845]
CellTagsIndexPosition[    144031,       3842]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.843793746059392*^9, 3.84379374698711*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"7490795e-ec79-44d2-9339-659e8d43a0d4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", "\"\</home/guanxin/mmapkg/external/finiteflow\>\""}],
    "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$LibraryPath", ",", "\"\</usr/local/lib\>\""}], "]"}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"$FrontEnd", "===", "Null"}], ",", "$InputFileName", ",", 
      RowBox[{"NotebookFileName", "[", "]"}]}], "]"}], "//", 
    "DirectoryName"}], "//", "SetDirectory"}], ";"}]}], "Code",
 InitializationCell->False,
 CellChangeTimes->{{3.843782677690461*^9, 3.8437826791540937`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"bcee2109-f71d-4233-9a9e-5bda9910c36d"],

Cell[BoxData[
 RowBox[{"<<", "FiniteFlow`"}]], "Input",
 CellChangeTimes->{{3.843782724519373*^9, 3.843782730431678*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"c0578b51-ebbb-4009-82be-708e2ec17a4a"],

Cell[CellGroupData[{

Cell["Useful wrappers", "Subsection",
 CellChangeTimes->{{3.843786391341064*^9, 3.843786397732506*^9}, 
   3.843787260439921*^9, {3.843788936832429*^9, 
   3.843788947847892*^9}},ExpressionUUID->"2a3fa6c6-1f27-4fb4-b7b6-\
30494f8e75f1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "mod", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"FFRatMod", "[", 
   RowBox[{
    RowBox[{"1", "/", "2"}], ",", "17"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843782732488378*^9, 3.843782738687422*^9}, {
  3.843786463626157*^9, 3.84378654840912*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"268a49d8-77f0-47be-a248-d0b7e494cd7d"],

Cell[BoxData["9"], "Output",
 CellChangeTimes->{{3.843786524199106*^9, 3.8437865415340967`*^9}, {
   3.843793737309842*^9, 3.843793755136455*^9}, 3.843796933137965*^9, 
   3.843805047342533*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"b415eae7-54a5-46b4-ac6b-b8e7677490a2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"rational", " ", "reconstruction"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"FFRatRec", "[", 
   RowBox[{"9", ",", "17"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843782732488378*^9, 3.843782738687422*^9}, {
  3.843786463626157*^9, 3.843786543915853*^9}, {3.8437865926550407`*^9, 
  3.843786592844802*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"8e7b7955-d527-43fc-b99d-df8debfaf9a0"],

Cell[BoxData[
 FractionBox["1", "2"]], "Output",
 CellChangeTimes->{
  3.843786469592668*^9, {3.843786519377068*^9, 3.843786544330051*^9}, 
   3.843793762905737*^9, 3.843796933869523*^9, 3.843805054868472*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"cb7f50d6-3734-414a-bd96-77029dace0f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"prime", " ", "should", " ", "be", " ", "large", " ", "enough"}], 
    ",", " ", 
    RowBox[{
    "otherwise", " ", "the", " ", "RR", " ", "would", " ", "failed"}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FFRatMod", "[", 
    RowBox[{
     RowBox[{"1", "/", "2000"}], ",", "17"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"FFRatRec", "[", 
    RowBox[{"%", ",", "17"}], "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843786554646319*^9, 3.843786615372037*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"7f020c5f-0b3d-4947-8e88-a140e07389a2"],

Cell[BoxData["14"], "Output",
 CellChangeTimes->{{3.8437865601654797`*^9, 3.843786563834978*^9}, 
   3.8437865959822407`*^9, 3.843793767789094*^9, 3.8437969346209297`*^9, 
   3.843805064979313*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"2c63deba-646b-4349-af7f-64ef61561b62"],

Cell[BoxData[
 RowBox[{"-", "3"}]], "Output",
 CellChangeTimes->{{3.8437865601654797`*^9, 3.843786563834978*^9}, 
   3.8437865959822407`*^9, 3.843793767789094*^9, 3.8437969346209297`*^9, 
   3.843805064980638*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"076d0061-4e65-4b50-b74b-9f7985a34436"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"FiniteFlow", " ", "provide", " ", "200", " ", "63"}], "-", 
    RowBox[{"bit", " ", "prime", " ", "numbers"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FFPrimeNo", "[", "0", "]"}], "\[IndentingNewLine]", 
   RowBox[{"FFPrimeNo", "[", "200", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8437868229885798`*^9, 3.843786914951015*^9}, 
   3.843803328620307*^9},ExpressionUUID->"949ead3e-7f9a-4453-87ce-\
783b883a4b19"],

Cell[BoxData["9223372036854775783"], "Output",
 CellChangeTimes->{{3.8437868900333977`*^9, 3.843786916022558*^9}, 
   3.8437937690483217`*^9, 3.843796935331918*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"a4f5c735-688a-4249-9887-a52624183275"],

Cell[BoxData["9223372036854766387"], "Output",
 CellChangeTimes->{{3.8437868900333977`*^9, 3.843786916022558*^9}, 
   3.8437937690483217`*^9, 3.843796935333009*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"2032d645-7b8a-4e76-aa7d-a277d6e74701"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"RR", " ", "succeed"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FFRatMod", "[", 
    RowBox[{
     RowBox[{"1", "/", "2000"}], ",", 
     RowBox[{"FFPrimeNo", "[", "0", "]"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"FFRatRec", "[", 
    RowBox[{"%", ",", 
     RowBox[{"FFPrimeNo", "[", "0", "]"}]}], "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843786928398513*^9, 3.843786955957725*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"0aaf8bfe-4b67-4ffa-a507-f97b0410c882"],

Cell[BoxData["2550262368190345504"], "Output",
 CellChangeTimes->{{3.8437869364491663`*^9, 3.843786958349998*^9}, 
   3.843793780539597*^9, 3.843796936014179*^9, 3.843805093196456*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"7699b955-bced-41ff-80dd-24b587c5d1a9"],

Cell[BoxData[
 FractionBox["1", "2000"]], "Output",
 CellChangeTimes->{{3.8437869364491663`*^9, 3.843786958349998*^9}, 
   3.843793780539597*^9, 3.843796936014179*^9, 3.8438050931986437`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"07cb70d5-31cc-4edd-977e-d441bb621080"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"linear", " ", 
    RowBox[{"solver", ":", " ", "dense"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"FFDenseSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"a1", " ", "x"}], " ", "+", " ", 
        RowBox[{"b1", " ", "y"}]}], " ", "==", " ", "c1"}], ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"a2", " ", "x"}], " ", "+", " ", 
        RowBox[{"b2", " ", "y"}]}], " ", "==", " ", "c2"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843786699515223*^9, 3.8437867066241493`*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"ce94372b-bef1-4547-ad8c-9841b3f22332"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"x", "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "b2"}], " ", "c1"}], "+", 
      RowBox[{"b1", " ", "c2"}]}], 
     RowBox[{
      RowBox[{"a2", " ", "b1"}], "-", 
      RowBox[{"a1", " ", "b2"}]}]]}], ",", 
   RowBox[{"y", "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{"a2", " ", "c1"}], "-", 
      RowBox[{"a1", " ", "c2"}]}], 
     RowBox[{
      RowBox[{"a2", " ", "b1"}], "-", 
      RowBox[{"a1", " ", "b2"}]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{3.8437867091792183`*^9, 3.843793786685615*^9, 
  3.843796937225439*^9, 3.8438051174177027`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"b9d9604e-7466-4b6e-a492-8d461e81c672"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"linear", " ", 
    RowBox[{"solver", ":", " ", "sparse"}]}], "*)"}], "\n", 
  RowBox[{"FFSparseSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"a1", " ", "x"}], " ", "+", " ", 
        RowBox[{"b1", " ", "y"}]}], " ", "==", " ", "c1"}], ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"a2", " ", "x"}], " ", "+", " ", 
        RowBox[{"b2", " ", "y"}]}], " ", "==", " ", "c2"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}]], "Code",
 CellChangeTimes->{{3.843786635723297*^9, 3.843786657577921*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"b1dd84f9-6ef3-4eaa-9f0f-a2e94b594ddd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"x", "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "b2"}], " ", "c1"}], "+", 
      RowBox[{"b1", " ", "c2"}]}], 
     RowBox[{
      RowBox[{"a2", " ", "b1"}], "-", 
      RowBox[{"a1", " ", "b2"}]}]]}], ",", 
   RowBox[{"y", "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{"a2", " ", "c1"}], "-", 
      RowBox[{"a1", " ", "c2"}]}], 
     RowBox[{
      RowBox[{"a2", " ", "b1"}], "-", 
      RowBox[{"a1", " ", "b2"}]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.843786659211102*^9, 3.84378671031081*^9, 3.843793787737672*^9, 
   3.843796938091942*^9, {3.843805119456067*^9, 3.84380512956336*^9}},
 CellLabel->"Out[13]=",ExpressionUUID->"507cd1cc-cdb1-4338-a502-f11ac0af7dea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"inverting", " ", "matrices"}], "*)"}], "\n", 
  RowBox[{"FFInverse", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"c", ",", "d"}], "}"}]}], "}"}], "]"}]}]], "Code",
 CellChangeTimes->{{3.843787430177177*^9, 3.843787439034384*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"6af8ac29-21ce-4ba0-9528-faec624e66c1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["d", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}]]}], ",", 
     FractionBox["b", 
      RowBox[{
       RowBox[{"b", " ", "c"}], "-", 
       RowBox[{"a", " ", "d"}]}]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     FractionBox["c", 
      RowBox[{
       RowBox[{"b", " ", "c"}], "-", 
       RowBox[{"a", " ", "d"}]}]], ",", 
     RowBox[{"-", 
      FractionBox["a", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}]]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.843787440491675*^9, 3.843793789780637*^9, 
  3.8437969387732277`*^9, 3.843805133768517*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"3dc9922a-37cb-49c2-9095-7bfc4cf05038"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "You", " ", "can", " ", "learn", " ", "more", " ", "by", " ", "reading", 
    " ", "the", " ", "documentation", " ", "of", " ", "these", " ", 
    "procedures"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"?", "FFSparseSolve"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8437871618634043`*^9, 3.843787179475976*^9}, {
  3.843787210387051*^9, 3.843787236689741*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"afc5e2a3-8e8c-4fd9-98bd-835ac38bbbe2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"FFSparseSolve[eqs,vars] reconstructs and returns \
the solutions of the linear system eqs in the variables vars using a sparse \
linear solver.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Definitions\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Definitions\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Definitions", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"FFSparseSolve", "[", 
                    RowBox[{
                    "FiniteFlow`Private`eqs_", ",", 
                    "FiniteFlow`Private`vars_", ",", 
                    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
                    RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "FiniteFlow`Private`params", ",", 
                    "FiniteFlow`Private`res", ",", "FiniteFlow`Private`graph",
                     ",", "FiniteFlow`Private`in", ",", 
                    "FiniteFlow`Private`sys", ",", "FiniteFlow`Private`learn",
                     ",", "FiniteFlow`Private`opt"}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"FiniteFlow`Private`opt", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    "#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "\[Rule]", 
                    RowBox[{"OptionValue", "[", 
                    RowBox[{
                    "#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "]"}]}], "&"}], ")"}], "/@", 
                    RowBox[{"Options", "[", "FFSparseSolve", "]"}]}]}], ";", 
                    RowBox[{
                    "FFNewGraph", "[", "FiniteFlow`Private`graph", "]"}], ";", 
                    RowBox[{"FiniteFlow`Private`res", "=", 
                    RowBox[{"Catch", "[", 
                    RowBox[{
                    RowBox[{"FiniteFlow`Private`params", "=", 
                    RowBox[{"OptionValue", "[", "\<\"Parameters\"\>", "]"}]}],
                     ";", 
                    RowBox[{"FiniteFlow`Private`params", "=", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    "FiniteFlow`Private`params", "\[Equal]", "Automatic"}], 
                    "]"}], ",", 
                    RowBox[{"Complement", "[", 
                    RowBox[{
                    RowBox[{"Variables", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    "#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", 
                    RowBox[{
                    "#1", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], "}"}], "&"}], ")"}], "/@", 
                    "FiniteFlow`Private`eqs"}], "]"}], ",", 
                    "FiniteFlow`Private`vars"}], "]"}], ",", 
                    "FiniteFlow`Private`params"}], "]"}]}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", 
                    RowBox[{"TrueQ", "[", 
                    RowBox[{"FiniteFlow`Private`params", "\[Equal]", 
                    RowBox[{"{", "}"}]}], "]"}]}], ",", 
                    RowBox[{
                    "FiniteFlow`Private`CheckVariables", "[", 
                    "FiniteFlow`Private`params", "]"}]}], "]"}], ";", 
                    RowBox[{"FFGraphInputVars", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", "FiniteFlow`Private`in", 
                    ",", "FiniteFlow`Private`params"}], "]"}], ";", 
                    RowBox[{"FiniteFlow`Private`res", "=", 
                    RowBox[{"FFAlgSparseSolver", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", "FiniteFlow`Private`sys",
                     ",", 
                    RowBox[{"{", "FiniteFlow`Private`in", "}"}], ",", 
                    "FiniteFlow`Private`params", ",", 
                    "FiniteFlow`Private`eqs", ",", "FiniteFlow`Private`vars", 
                    ",", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"FilterRules", "[", 
                    RowBox[{
                    RowBox[{"{", "FiniteFlow`Private`opt", "}"}], ",", 
                    RowBox[{"Options", "[", "FFAlgSparseSolver", "]"}]}], 
                    "]"}]}]}], "]"}]}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"FiniteFlow`Private`res", "\[Equal]", "$Failed"}],
                     ",", 
                    RowBox[{"Throw", "[", "$Failed", "]"}]}], "]"}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"!", 
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    "OptionValue", "[", "\<\"IndepVarsOnly\"\>", "]"}], 
                    "]"}]}], "&&", 
                    RowBox[{"TrueQ", "[", 
                    RowBox[{"OptionValue", "[", "\<\"SparseOutput\"\>", "]"}],
                     "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"FFSolverSparseOutput", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", 
                    "FiniteFlow`Private`sys"}], "]"}], ";"}]}], "]"}], ";", 
                    RowBox[{"FFGraphOutput", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", 
                    "FiniteFlow`Private`sys"}], "]"}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    "OptionValue", "[", "\<\"IndepVarsOnly\"\>", "]"}], "]"}],
                     ",", 
                    RowBox[{
                    RowBox[{"FFSetLearningOptions", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", "FiniteFlow`Private`sys",
                     ",", 
                    RowBox[{"\<\"PrimeNo\"\>", "\[Rule]", 
                    RowBox[{
                    "OptionValue", "[", "\<\"StartingPrimeNo\"\>", "]"}]}]}], 
                    "]"}], ";"}]}], "]"}], ";", 
                    RowBox[{"FiniteFlow`Private`learn", "=", 
                    RowBox[{"FFSparseSolverLearn", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", 
                    "FiniteFlow`Private`vars"}], "]"}]}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", 
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{
                    "FiniteFlow`Private`learn", "\[LeftDoubleBracket]", "0", 
                    "\[RightDoubleBracket]"}], "\[Equal]", "List"}], "]"}]}], 
                    ",", 
                    RowBox[{"Throw", "[", "FiniteFlow`Private`learn", "]"}]}],
                     "]"}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    "OptionValue", "[", "\<\"IndepVarsOnly\"\>", "]"}], "]"}],
                     ",", 
                    RowBox[{"Throw", "[", 
                    
                    RowBox[{"\<\"IndepVars\"\>", "/.", "\[VeryThinSpace]", 
                    "FiniteFlow`Private`learn"}], "]"}]}], "]"}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"TrueQ", "[", 
                    RowBox[{"OptionValue", "[", "\<\"MarkAndSweep\"\>", "]"}],
                     "]"}], ",", 
                    RowBox[{
                    RowBox[{"FFSparseSolverMarkAndSweepEqs", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", 
                    "FiniteFlow`Private`sys"}], "]"}], ";", 
                    RowBox[{"FFSparseSolverDeleteUnneededEqs", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", 
                    "FiniteFlow`Private`sys"}], "]"}], ";"}]}], "]"}], ";", 
                    RowBox[{"FiniteFlow`Private`res", "=", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"TrueQ", "[", 
                    RowBox[{"FiniteFlow`Private`params", "\[Equal]", 
                    RowBox[{"{", "}"}]}], "]"}], ",", 
                    RowBox[{"FFReconstructNumeric", "[", 
                    RowBox[{"FiniteFlow`Private`graph", ",", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"FilterRules", "[", 
                    RowBox[{
                    RowBox[{"{", "FiniteFlow`Private`opt", "}"}], ",", 
                    RowBox[{"Options", "[", "FFReconstructNumeric", "]"}]}], 
                    "]"}]}]}], "]"}], ",", 
                    RowBox[{"FFReconstructFunction", "[", 
                    RowBox[{
                    "FiniteFlow`Private`graph", ",", 
                    "FiniteFlow`Private`params", ",", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"FilterRules", "[", 
                    RowBox[{
                    RowBox[{"{", "FiniteFlow`Private`opt", "}"}], ",", 
                    RowBox[{"Options", "[", "FFReconstructFunction", "]"}]}], 
                    "]"}]}]}], "]"}]}], "]"}]}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", 
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{
                    "FiniteFlow`Private`res", "\[LeftDoubleBracket]", "0", 
                    "\[RightDoubleBracket]"}], "\[Equal]", "List"}], "]"}]}], 
                    ",", 
                    RowBox[{"Throw", "[", "FiniteFlow`Private`res", "]"}]}], 
                    "]"}], ";", 
                    RowBox[{"FFSparseSolverSol", "[", 
                    RowBox[{
                    "FiniteFlow`Private`res", ",", 
                    "FiniteFlow`Private`learn"}], "]"}]}], "]"}]}], ";", 
                    RowBox[{
                    "FFDeleteGraph", "[", "FiniteFlow`Private`graph", "]"}], 
                    ";", "FiniteFlow`Private`res"}]}], "]"}]}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    
                    StyleBox["\<\" Default Definitions\"\>", 
                    "InformationRowLabel",
                    StripOnInput->False],
                    "\"DefaultValues\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "DefaultValues", "Tooltip"]& ], 
                   InterpretationBox[GridBox[{
                    {
                    RowBox[{
                    RowBox[{"Options", "[", "FFSparseSolve", "]"}], ":=", 
                    RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\<\"Parameters\"\>", "\[Rule]", "Automatic"}], 
                    ",", 
                    RowBox[{"\<\"IndepVarsOnly\"\>", "\[Rule]", "False"}], 
                    ",", 
                    RowBox[{"\<\"MarkAndSweep\"\>", "\[Rule]", "True"}], ",", 
                    
                    RowBox[{"\<\"SparseOutput\"\>", "\[Rule]", "False"}]}], 
                    "}"}], ",", 
                    RowBox[{
                    "FiniteFlow`Private`AutoReconstructionOptions", "[", 
                    "]"}], ",", 
                    RowBox[{"Options", "[", "FFAlgSparseSolver", "]"}]}], 
                    "]"}]}]}
                    },
                    BaselinePosition->{Baseline, {1, 1}},
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Baseline}}}],
                    
                    ColumnForm[{
                    Options[FiniteFlow`FFSparseSolve] := 
                    Join[{"Parameters" -> Automatic, "IndepVarsOnly" -> False,
                     "MarkAndSweep" -> True, "SparseOutput" -> False}, 
                    FiniteFlow`Private`AutoReconstructionOptions[], 
                    Options[FiniteFlow`FFAlgSparseSolver]]}],
                    Editable->False]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"FiniteFlow`FFSparseSolve\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"FFSparseSolve[eqs,vars] reconstructs and returns \
the solutions of the linear system eqs in the variables vars using a sparse \
linear solver.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "FFSparseSolve[eqs,vars] reconstructs and returns the solutions of the \
linear system eqs in the variables vars using a sparse linear solver.", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> 
    Information`InformationValueForm[
     DownValues, FiniteFlow`FFSparseSolve, {FiniteFlow`FFSparseSolve[
         Pattern[FiniteFlow`Private`eqs, 
          Blank[]], 
         Pattern[FiniteFlow`Private`vars, 
          Blank[]], 
         OptionsPattern[]] :> 
       Module[{FiniteFlow`Private`params, FiniteFlow`Private`res, 
          FiniteFlow`Private`graph, FiniteFlow`Private`in, 
          FiniteFlow`Private`sys, FiniteFlow`Private`learn, 
          FiniteFlow`Private`opt}, 
         FiniteFlow`Private`opt = Map[Part[#, 1] -> OptionValue[
              Part[#, 1]]& , 
            Options[FiniteFlow`FFSparseSolve]]; 
         FiniteFlow`FFNewGraph[FiniteFlow`Private`graph]; 
         FiniteFlow`Private`res = 
          Catch[FiniteFlow`Private`params = OptionValue["Parameters"]; 
            FiniteFlow`Private`params = If[
               TrueQ[FiniteFlow`Private`params == Automatic], 
               Complement[
                Variables[
                 Map[{
                   Part[#, 1], 
                   Part[#, 2]}& , FiniteFlow`Private`eqs]], 
                FiniteFlow`Private`vars], FiniteFlow`Private`params]; If[
              Not[
               TrueQ[FiniteFlow`Private`params == {}]], 
              FiniteFlow`Private`CheckVariables[FiniteFlow`Private`params]]; 
            FiniteFlow`FFGraphInputVars[
             FiniteFlow`Private`graph, FiniteFlow`Private`in, 
              FiniteFlow`Private`params]; 
            FiniteFlow`Private`res = 
             FiniteFlow`FFAlgSparseSolver[
              FiniteFlow`Private`graph, FiniteFlow`Private`sys, {
               FiniteFlow`Private`in}, FiniteFlow`Private`params, 
               FiniteFlow`Private`eqs, FiniteFlow`Private`vars, 
               Apply[Sequence, 
                FilterRules[{FiniteFlow`Private`opt}, 
                 Options[FiniteFlow`FFAlgSparseSolver]]]]; 
            If[FiniteFlow`Private`res == $Failed, 
              Throw[$Failed]]; If[
              And[
               Not[
                TrueQ[
                 OptionValue["IndepVarsOnly"]]], 
               TrueQ[
                OptionValue["SparseOutput"]]], 
              FiniteFlow`FFSolverSparseOutput[
               FiniteFlow`Private`graph, FiniteFlow`Private`sys]; Null]; 
            FiniteFlow`FFGraphOutput[
             FiniteFlow`Private`graph, FiniteFlow`Private`sys]; If[
              TrueQ[
               OptionValue["IndepVarsOnly"]], 
              FiniteFlow`FFSetLearningOptions[
               FiniteFlow`Private`graph, FiniteFlow`Private`sys, "PrimeNo" -> 
                OptionValue["StartingPrimeNo"]]; Null]; 
            FiniteFlow`Private`learn = 
             FiniteFlow`FFSparseSolverLearn[
              FiniteFlow`Private`graph, FiniteFlow`Private`vars]; If[
              Not[
               TrueQ[Part[FiniteFlow`Private`learn, 0] == List]], 
              Throw[FiniteFlow`Private`learn]]; If[
              TrueQ[
               OptionValue["IndepVarsOnly"]], 
              Throw[
               ReplaceAll["IndepVars", FiniteFlow`Private`learn]]]; If[
              TrueQ[
               OptionValue["MarkAndSweep"]], 
              FiniteFlow`FFSparseSolverMarkAndSweepEqs[
               FiniteFlow`Private`graph, FiniteFlow`Private`sys]; 
              FiniteFlow`FFSparseSolverDeleteUnneededEqs[
               FiniteFlow`Private`graph, FiniteFlow`Private`sys]; Null]; 
            FiniteFlow`Private`res = If[
               TrueQ[FiniteFlow`Private`params == {}], 
               FiniteFlow`FFReconstructNumeric[FiniteFlow`Private`graph, 
                Apply[Sequence, 
                 FilterRules[{FiniteFlow`Private`opt}, 
                  Options[FiniteFlow`FFReconstructNumeric]]]], 
               FiniteFlow`FFReconstructFunction[
               FiniteFlow`Private`graph, FiniteFlow`Private`params, 
                Apply[Sequence, 
                 FilterRules[{FiniteFlow`Private`opt}, 
                  Options[FiniteFlow`FFReconstructFunction]]]]]; If[
              Not[
               TrueQ[Part[FiniteFlow`Private`res, 0] == List]], 
              Throw[FiniteFlow`Private`res]]; 
            FiniteFlow`FFSparseSolverSol[
             FiniteFlow`Private`res, FiniteFlow`Private`learn]]; 
         FiniteFlow`FFDeleteGraph[FiniteFlow`Private`graph]; 
         FiniteFlow`Private`res]}], "SubValues" -> None, "DefaultValues" -> 
    Information`InformationValueForm[
     DefaultValues, FiniteFlow`FFSparseSolve, {
      Options[FiniteFlow`FFSparseSolve] :> 
       Join[{"Parameters" -> Automatic, "IndepVarsOnly" -> False, 
          "MarkAndSweep" -> True, "SparseOutput" -> False}, 
         FiniteFlow`Private`AutoReconstructionOptions[], 
         Options[FiniteFlow`FFAlgSparseSolver]]}], "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "FiniteFlow`FFSparseSolve"], False]]], "Output",
 CellChangeTimes->{3.843787166314557*^9, 3.843793795026887*^9, 
  3.8437969400185537`*^9, 3.843805142237954*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"fe94655f-ca3a-40aa-a1bf-1276bef2b190"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "and", " ", "looking", " ", "at", " ", "the", " ", "available", " ", 
    "Options"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Options", "[", "FFSparseSolve", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843786747783258*^9, 3.8437867487549667`*^9}, {
  3.843787248756024*^9, 3.843787250735877*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"7568cb61-3ddc-4be1-9049-7271c7d016de"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"Parameters\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"IndepVarsOnly\"\>", "\[Rule]", "False"}], ",", 
   RowBox[{"\<\"MarkAndSweep\"\>", "\[Rule]", "True"}], ",", 
   RowBox[{"\<\"SparseOutput\"\>", "\[Rule]", "False"}], ",", 
   RowBox[{"\<\"Checks\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"UChecks\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"MaxSingularPoints\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"StartingPrimeNo\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"MaxPrimes\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"MaxDegree\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"PrintDebugInfo\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"NThreads\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"MinPrimes\"\>", "\[Rule]", "1"}], ",", 
   RowBox[{"\<\"NeededVars\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"ApplyFunction\"\>", "\[Rule]", "Identity"}], ",", 
   RowBox[{"\<\"VarsPattern\"\>", "\[Rule]", "Automatic"}]}], "}"}]], "Output",\

 CellChangeTimes->{3.8437867490198383`*^9, 3.843793797507696*^9, 
  3.8437969409140167`*^9, 3.843805152560997*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"2bcf135a-993f-4619-8202-e8b50b6eb8f1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic usage", "Subsection",
 CellChangeTimes->{{3.8437872691915207`*^9, 
  3.843787271239167*^9}},ExpressionUUID->"f5bf0ffb-5bb0-43b8-9898-\
1ea06e9bbc74"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"define", " ", "new", " ", "graph"}], "*)"}], "\n", 
  RowBox[{"FFNewGraph", "[", "mygraph", "]"}]}]], "Code",
 CellChangeTimes->{{3.843787742021215*^9, 3.843787747899173*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"8c4d53ce-3371-4382-acbd-6842e7b84292"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.843787644711196*^9, 3.843787775896559*^9, 
  3.8437881945438232`*^9, 3.843793806987352*^9, 3.843796942304133*^9, 
  3.8438051971164417`*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"2603cbec-4d7b-4a22-9410-7fc28ad858cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"define", " ", "input", " ", "node"}], "*)"}], "\n", 
  RowBox[{"FFGraphInputVars", "[", 
   RowBox[{"mygraph", ",", "input", ",", 
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}]}], "]"}]}]], "Code",
 CellChangeTimes->{{3.843787751461344*^9, 3.843787759098963*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"7fb5d1c7-f008-43e5-a4ce-7168a250b2b8"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.843787656382956*^9, 3.8437877767342243`*^9, 
  3.84378819511806*^9, 3.843793808587634*^9, 3.843796942995573*^9, 
  3.843805208190978*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"4f9cb801-41a0-45e7-b3dd-f1bf64175cd7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"name", " ", "of", " ", "vars", " ", "are", " ", "irrelevant"}], 
   "*)"}], "\n", 
  RowBox[{"FFGraphInputVars", "[", 
   RowBox[{"mygraph", ",", "input", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}]}]], "Code",
 CellChangeTimes->{{3.843787796587805*^9, 3.843787828391898*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"887c7388-5398-446a-af8e-04302199730d"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.843787660262136*^9, 3.8437877865634108`*^9, 3.843787830248085*^9, {
   3.843788148209261*^9, 3.8437881653116093`*^9}, 3.843788196454977*^9, 
   3.843793809692706*^9, 3.8437969436977463`*^9, 3.843805216425189*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"71c33d3f-4a87-4358-b209-dfd0520a1195"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "shortcut", "*)"}], "\n", 
  RowBox[{"FFNewGraph", "[", 
   RowBox[{"mygraph", ",", "input", ",", 
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}]}], "]"}]}]], "Code",
 CellChangeTimes->{{3.843787832347439*^9, 3.843787837343747*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"e7cf5298-6c65-4bce-bc53-2c55339c8deb"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.84378766356067*^9, 3.8437877870361137`*^9, 3.843787838267262*^9, {
   3.843788162838819*^9, 3.8437881666002502`*^9}, 3.843788196958314*^9, 
   3.8437938104361677`*^9, 3.843796944330798*^9, 3.8438052302460957`*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"11eda697-e315-4060-9bee-74e423b93094"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"New", ",", " ", 
   RowBox[{
   "we", " ", "want", " ", "to", " ", "define", " ", "some", " ", 
    "algorithms", " ", "in", " ", "graph", " ", "and", " ", "combine", " ", 
    "them", " ", "together", " ", "in", " ", "a", " ", "more", " ", "complex",
     " ", "calculation"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.8437876873599997`*^9, 3.843787691787046*^9}, {
  3.84378784829666*^9, 3.84378789724518*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"2021dd90-2446-431a-a1f5-b48b02643c4d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFAlgRatFunEval", "[", 
  RowBox[{"mygraph", ",", "fun1", ",", 
   RowBox[{"{", "input", "}"}], ",", "\n", "                ", 
   RowBox[{"{", 
    RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], ",", "\n", 
   "                ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "x1"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", "x2"}], ")"}]}], ",", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "x2"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", "x3"}], ")"}]}], ",", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "x1"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", "x3"}], ")"}]}], ",", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"x1", "^", "2"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"x2", "^", "2"}]}], ")"}]}]}], "}"}]}], "]"}]], "Code",
 CellLabel->"In[22]:=",ExpressionUUID->"78b0caee-0ceb-4d6e-96e9-3149d3d3ed94"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.8437878420316563`*^9, 3.843788168201248*^9, 
  3.843788198840569*^9, 3.8437969452441196`*^9, 3.843805292628901*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"ac340d23-8fbf-474f-a13e-4ebdfef2624f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"evaluation", " ", "of", " ", "rational", " ", "functions"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"?", "FFAlgRatFunEval"}]}]], "Input",
 CellChangeTimes->{{3.8437876873599997`*^9, 3.843787691787046*^9}, {
  3.84378784829666*^9, 3.843787915494299*^9}, {3.843793820261526*^9, 
  3.843793825369378*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"99e3f974-2fbe-4d76-83bb-6c1e05e174cc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"FFAlgRatFunEval[graph,node,{input},vars,funs] \
evaluates and returns the list of rational functions funs in the variables \
vars.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Definitions\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Definitions\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Definitions", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"FFAlgRatFunEval", "[", 
                    RowBox[{
                    "FiniteFlow`Private`gid_", ",", "FiniteFlow`Private`id_", 
                    ",", "FiniteFlow`Private`inputs_List", ",", 
                    "FiniteFlow`Private`params_", ",", 
                    "FiniteFlow`Private`functions_List"}], "]"}], ":=", 
                    RowBox[{"FFRegisterAlgorithm", "[", 
                    RowBox[{
                    "FiniteFlow`Private`RegisterAlgRatFunEval", ",", 
                    "FiniteFlow`Private`gid", ",", "FiniteFlow`Private`id", 
                    ",", "FiniteFlow`Private`inputs", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    "FiniteFlow`Private`params", ",", 
                    "FiniteFlow`Private`functions"}], "}"}]}], "]"}]}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"FiniteFlow`FFAlgRatFunEval\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"FFAlgRatFunEval[graph,node,{input},vars,funs] \
evaluates and returns the list of rational functions funs in the variables \
vars.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "FFAlgRatFunEval[graph,node,{input},vars,funs] evaluates and returns the \
list of rational functions funs in the variables vars.", "Documentation" -> 
    None, "OwnValues" -> None, "UpValues" -> None, "DownValues" -> 
    Information`InformationValueForm[
     DownValues, FiniteFlow`FFAlgRatFunEval, {FiniteFlow`FFAlgRatFunEval[
         Pattern[FiniteFlow`Private`gid, 
          Blank[]], 
         Pattern[FiniteFlow`Private`id, 
          Blank[]], 
         Pattern[FiniteFlow`Private`inputs, 
          Blank[List]], 
         Pattern[FiniteFlow`Private`params, 
          Blank[]], 
         Pattern[FiniteFlow`Private`functions, 
          Blank[List]]] :> 
       FiniteFlow`FFRegisterAlgorithm[
        FiniteFlow`Private`RegisterAlgRatFunEval, FiniteFlow`Private`gid, 
         FiniteFlow`Private`id, FiniteFlow`Private`inputs, {
         FiniteFlow`Private`params, FiniteFlow`Private`functions}]}], 
    "SubValues" -> None, "DefaultValues" -> None, "NValues" -> None, 
    "FormatValues" -> None, "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "FiniteFlow`FFAlgRatFunEval"], False]]], "Output",
 CellChangeTimes->{3.843787692597273*^9, 3.8437969464436493`*^9, 
  3.843805254425148*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"1b6f1930-78e8-48fe-bb91-544b0cac65a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFAlgRatFunEval", "[", 
  RowBox[{"mygraph", ",", "fun2", ",", 
   RowBox[{"{", "input", "}"}], ",", "\n", "                ", 
   RowBox[{"{", 
    RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], ",", "\n", 
   "                ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"x2", "^", "2"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"x3", "^", "2"}]}], ")"}]}], ",", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"x1", "^", "2"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"x3", "^", "2"}]}], ")"}]}], ",", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"x1", "^", "2"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"x2", "^", "2"}]}], ")"}]}], ",", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"x1", "^", "2"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"x3", "^", "2"}]}], ")"}]}]}], "}"}]}], "]"}]], "Code",
 CellLabel->"In[23]:=",ExpressionUUID->"5565fd79-fb68-4aab-837c-449e9d26eef8"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.843787842798419*^9, 3.843788168770698*^9, 
  3.843788199735908*^9, 3.843796947112781*^9, 3.843805296971662*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"ef415d0f-b8ef-4d62-a994-2d6280fd6e41"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "matric", " ", "multiplication", " ", "between", " ", "fun1", " ", "and", 
    " ", "fun2"}], "*)"}], "\n", 
  RowBox[{"?", "FFAlgMatMul"}]}]], "Code",
 CellChangeTimes->{{3.8437879207321253`*^9, 3.843787974224614*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"29bcb41a-fa7b-4807-bcce-5f6865961562"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"FFAlgMatMul[graph,node,{input1,input2},r1,c1,c2], \
with integers r1,c1,c2, interprets input1 and input2 as the elements of a r1 \
\[Times] c1 matrix and a c1 \[Times] c2 matrix respectively, in row-major \
order, and returns the result of the matrix multiplication \
input1.input2.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False, False, False, False, 
                False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Definitions\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"Definitions\"",
                    TooltipStyle->"TextStyling"],
                    Annotation[#, "Definitions", "Tooltip"]& ], GridBox[{
                    {
                    RowBox[{
                    RowBox[{"FFAlgMatMul", "[", 
                    RowBox[{
                    "FiniteFlow`Private`gid_", ",", "FiniteFlow`Private`id_", 
                    ",", "FiniteFlow`Private`inputs_List", ",", 
                    "FiniteFlow`Private`rows1_", ",", 
                    "FiniteFlow`Private`cols1_", ",", 
                    "FiniteFlow`Private`cols2_"}], "]"}], ":=", 
                    RowBox[{"FFRegisterAlgorithm", "[", 
                    RowBox[{
                    "FiniteFlow`Private`RegisterAlgMatMul", ",", 
                    "FiniteFlow`Private`gid", ",", "FiniteFlow`Private`id", 
                    ",", "FiniteFlow`Private`inputs", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    "FiniteFlow`Private`rows1", ",", 
                    "FiniteFlow`Private`cols1", ",", 
                    "FiniteFlow`Private`cols2"}], "}"}]}], "]"}]}]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"FiniteFlow`FFAlgMatMul\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->6], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"FFAlgMatMul[graph,node,{input1,input2},r1,c1,c2], \
with integers r1,c1,c2, interprets input1 and input2 as the elements of a r1 \
\[Times] c1 matrix and a c1 \[Times] c2 matrix respectively, in row-major \
order, and returns the result of the matrix multiplication \
input1.input2.\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{10., {2., 8.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{10., {2., 8.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[
   Association[
   "ObjectType" -> "Symbol", "Usage" -> 
    "FFAlgMatMul[graph,node,{input1,input2},r1,c1,c2], with integers \
r1,c1,c2, interprets input1 and input2 as the elements of a r1 \[Times] c1 \
matrix and a c1 \[Times] c2 matrix respectively, in row-major order, and \
returns the result of the matrix multiplication input1.input2.", 
    "Documentation" -> None, "OwnValues" -> None, "UpValues" -> None, 
    "DownValues" -> 
    Information`InformationValueForm[
     DownValues, FiniteFlow`FFAlgMatMul, {FiniteFlow`FFAlgMatMul[
         Pattern[FiniteFlow`Private`gid, 
          Blank[]], 
         Pattern[FiniteFlow`Private`id, 
          Blank[]], 
         Pattern[FiniteFlow`Private`inputs, 
          Blank[List]], 
         Pattern[FiniteFlow`Private`rows1, 
          Blank[]], 
         Pattern[FiniteFlow`Private`cols1, 
          Blank[]], 
         Pattern[FiniteFlow`Private`cols2, 
          Blank[]]] :> 
       FiniteFlow`FFRegisterAlgorithm[
        FiniteFlow`Private`RegisterAlgMatMul, FiniteFlow`Private`gid, 
         FiniteFlow`Private`id, FiniteFlow`Private`inputs, {
         FiniteFlow`Private`rows1, FiniteFlow`Private`cols1, 
          FiniteFlow`Private`cols2}]}], "SubValues" -> None, "DefaultValues" -> 
    None, "NValues" -> None, "FormatValues" -> None, "Options" -> None, 
    "Attributes" -> {}, "FullName" -> "FiniteFlow`FFAlgMatMul"], 
   False]]], "Output",
 CellChangeTimes->{3.843787975267198*^9, 3.843796947896285*^9, 
  3.843805311262187*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"bcd152b6-24c7-40d5-b310-bc38c99f470f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFAlgMatMul", "[", 
  RowBox[{"mygraph", ",", "matmul", ",", 
   RowBox[{"{", 
    RowBox[{"fun1", ",", "fun2"}], "}"}], ",", "2", ",", "2", ",", "2"}], 
  "]"}]], "Code",
 CellChangeTimes->{{3.8437879207321253`*^9, 3.843787974224614*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"2f1f8c2b-ad6e-4093-ac3c-234d5c2ee6af"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.843787970841515*^9, 3.8437879763269453`*^9}, 
   3.843788170998579*^9, 3.8437882015456753`*^9, 3.843796948911929*^9, 
   3.843805362996587*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"5508554a-83db-47cd-8686-38840fe953c9"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"FFGraphOutput", "[", 
  RowBox[{"mygraph", ",", "matmul"}], "]"}]], "Code",
 CellLabel->"In[27]:=",ExpressionUUID->"cbccdd42-db78-42e8-a6f3-c9d726aff822"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFGraphDraw", "[", "mygraph", "]"}]], "Code",
 CellLabel->"In[28]:=",ExpressionUUID->"551c2d10-8e11-46a4-a14a-5987778691a1"],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[Medium], 
    ArrowBox[{{0., 2.}, {0., 1.}}, 0.02261146496815286], 
    ArrowBox[{{0., 2.}, {1., 1.}}, 0.02261146496815286], 
    ArrowBox[{{0., 1.}, {0., 0.}}, 0.02261146496815286], 
    ArrowBox[{{1., 1.}, {0., 0.}}, 0.02261146496815286]}, 
   {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
    0.7]}], {DiskBox[{0., 2.}, 0.02261146496815286], 
     InsetBox["input", 
      Offset[{2, 2}, {0.02261146496815286, 2.022611464968153}], ImageScaled[{0, 0}],
      BaseStyle->"Graphics"]}, {DiskBox[{0., 1.}, 0.02261146496815286], 
     InsetBox["fun1", 
      Offset[{2, 2}, {0.02261146496815286, 1.0226114649681528}], ImageScaled[{0, 0}],
      BaseStyle->"Graphics"]}, {DiskBox[{1., 1.}, 0.02261146496815286], 
     InsetBox["fun2", 
      Offset[{2, 2}, {1.0226114649681528, 1.0226114649681528}], ImageScaled[{0, 0}],
      BaseStyle->"Graphics"]}, {DiskBox[{0., 0.}, 0.02261146496815286], 
     InsetBox["matmul", 
      Offset[{2, 2}, {0.02261146496815286, 0.02261146496815286}], 
      ImageScaled[{0, 0}],
      BaseStyle->"Graphics"]}}},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{
  3.843787985108939*^9, 3.8437881714128532`*^9, {3.843788202814682*^9, 
   3.843788226414456*^9}, 3.843796950459217*^9, 3.8438053699088984`*^9},
 CellLabel->"Out[28]=",ExpressionUUID->"5dd36d63-ed6e-4f57-abfa-fd6bf8103ec0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"evaluation", " ", "over", " ", "finite", " ", "fields"}], "*)"}], 
  "\n", 
  RowBox[{"FFGraphEvaluate", "[", 
   RowBox[{"mygraph", ",", 
    RowBox[{"{", 
     RowBox[{"123", ",", "345", ",", "567"}], "}"}], ",", 
    RowBox[{"\"\<PrimeNo\>\"", "->", "0"}]}], "]"}]}]], "Code",
 CellChangeTimes->{{3.8437880002485447`*^9, 3.843788025028702*^9}},
 CellLabel->"In[29]:=",ExpressionUUID->"bce0dd3a-b2bd-4200-8415-8d9dc2d69690"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "8760960470690695587", ",", "8837580472873504211", ",", 
   "7538290598036959547", ",", "4835712366129975840"}], "}"}]], "Output",
 CellChangeTimes->{
  3.843788172677897*^9, {3.843788204870598*^9, 3.8437882278487787`*^9}, 
   3.843788398936686*^9, 3.843796951946224*^9, 3.8438054335359793`*^9},
 CellLabel->"Out[29]=",ExpressionUUID->"6ccebac9-631c-4e4c-9899-2f7a214e85cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "the", " ", "output", " ", "is", " ", "a", " ", "list", " ", "of", " ", 
     "length", " ", "4.", " ", "in", " ", "this", " ", "case"}], ",", " ", 
    RowBox[{
    "it", " ", "represent", " ", "the", " ", "elements", " ", "of", " ", 
     "the", " ", "2", "*", "2", " ", "matrix", "\n", "computed", " ", "via", 
     " ", "matric", " ", "multiplication", " ", "algorithm"}]}], "*)"}], "\n", 
  RowBox[{
   RowBox[{"ArrayReshape", "[", 
    RowBox[{"%", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "//", "MatrixForm"}]}]], "Code",\

 CellChangeTimes->{{3.8437883481376753`*^9, 3.843788395831787*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"c082d7dd-f5c1-4287-b4b7-0d66369fa07b"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"8760960470690695587", "8837580472873504211"},
     {"7538290598036959547", "4835712366129975840"}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.84378839718607*^9, 3.843788399474094*^9}, 
   3.8437969528614607`*^9, 3.843805445445485*^9},
 CellLabel->
  "Out[30]//MatrixForm=",ExpressionUUID->"abe2d188-443b-4b41-b768-\
efc0351885b3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"multithread", " ", "evaluation"}], "*)"}], "\n", 
  RowBox[{"FFGraphEvaluateMany", "[", 
   RowBox[{"mygraph", ",", 
    RowBox[{"RandomInteger", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{
         RowBox[{"FFPrimeNo", "[", "0", "]"}], "-", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "3"}], "}"}]}], "]"}], ",", 
    RowBox[{"\"\<NThreads\>\"", "\[Rule]", "3"}]}], "]"}]}]], "Code",
 CellChangeTimes->{{3.8437880002485447`*^9, 3.843788101627586*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"c52b870d-7194-4de2-85f3-cfcce1494504"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "5352840599787498980", ",", "1058545799066333744", ",", 
     "2924497086349410699", ",", "3647675200225605200"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "2323766878575936095", ",", "3363672071543539728", ",", 
     "6367359305781467783", ",", "572876466048777434"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "8316598799710643224", ",", "1713150940824327797", ",", 
     "3441347071953601221", ",", "8031236373730322966"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.843788229328022*^9, 3.843788411678151*^9, 
  3.84379695366262*^9, 3.8438054888205*^9},
 CellLabel->"Out[31]=",ExpressionUUID->"f73087f3-0fc4-4018-ba4c-dbe95b879524"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "FFGraphEvaluateMany", "]"}]], "Input",
 InitializationCell->True,
 CellLabel->"In[32]:=",ExpressionUUID->"54a77de4-4c97-4406-91aa-748b7960408b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"PrimeNo\"\>", "\[Rule]", "0"}], ",", 
   RowBox[{"\<\"NThreads\"\>", "\[Rule]", "Automatic"}]}], "}"}]], "Output",
 CellChangeTimes->{3.843788143038024*^9, 3.84378824482565*^9, 
  3.843788413556497*^9, 3.843796954853345*^9, 3.8438054948045588`*^9},
 CellLabel->"Out[32]=",ExpressionUUID->"067e1ca4-bfda-4e19-b759-2f0e9fdef806"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"reconstruction", " ", "under", " ", "finite", " ", "field"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"FFReconstructFunctionMod", "[", 
   RowBox[{"mygraph", ",", 
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], ",", 
    RowBox[{"\"\<StartingPrimeNo\>\"", "\[Rule]", "2"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843788282566502*^9, 3.843788335242716*^9}, {
  3.8438055376937847`*^9, 3.8438055435819693`*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"be6675e8-cd01-493b-8d1a-6812e6ab04dd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2", "+", "x1", "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"]}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", "x2"}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"], " ", "x2"}], "+", 
      SuperscriptBox["x2", "2"], "+", 
      RowBox[{"x1", " ", 
       SuperscriptBox["x2", "2"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "3"]}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", 
       SuperscriptBox["x2", "3"]}], "+", "x3", "+", 
      RowBox[{"x1", " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", "x2", " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", "x2", " ", "x3"}], "+", 
      RowBox[{
       SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
      RowBox[{"x1", " ", 
       SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "3"], " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", 
       SuperscriptBox["x2", "3"], " ", "x3"}], "+", 
      SuperscriptBox["x3", "2"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"], " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{"x2", " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"], " ", "x2", " ", 
       SuperscriptBox["x3", "2"]}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "2"]}], "+", "x3", "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
      SuperscriptBox["x3", "2"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "2"], " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      SuperscriptBox["x3", "3"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "2"], " ", 
       SuperscriptBox["x3", "3"]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2", "+", "x1", "+", 
      SuperscriptBox["x1", "3"], "+", 
      RowBox[{"2", " ", "x2"}], "+", 
      RowBox[{"9223372036854775547", " ", 
       SuperscriptBox["x1", "2"], " ", "x2"}], "+", 
      SuperscriptBox["x2", "2"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"], " ", 
       SuperscriptBox["x2", "2"]}], "+", "x3", "+", 
      RowBox[{"x1", " ", "x3"}], "+", 
      RowBox[{
       SuperscriptBox["x1", "2"], " ", "x3"}], "+", 
      RowBox[{
       SuperscriptBox["x1", "3"], " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{"9223372036854775547", " ", 
       SuperscriptBox["x1", "2"], " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "3"], " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{"2", " ", "x2", " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{"9223372036854775547", " ", 
       SuperscriptBox["x1", "2"], " ", "x2", " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["x2", "2"], " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"], " ", 
       SuperscriptBox["x2", "2"], " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x3", "3"]}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", 
       SuperscriptBox["x3", "3"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"], " ", 
       SuperscriptBox["x3", "3"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "3"], " ", 
       SuperscriptBox["x3", "3"]}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", "x2", "+", "x3", "+", 
      RowBox[{"x2", " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x3", "4"]}], "+", 
      RowBox[{"9223372036854775548", " ", "x2", " ", 
       SuperscriptBox["x3", "4"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x3", "5"]}], "+", 
      RowBox[{"9223372036854775548", " ", "x2", " ", 
       SuperscriptBox["x3", "5"]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2", "+", "x1", "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "4"]}], "+", 
      SuperscriptBox["x2", "2"], "+", 
      RowBox[{"x1", " ", 
       SuperscriptBox["x2", "2"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "4"]}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", 
       SuperscriptBox["x2", "4"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "6"]}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", 
       SuperscriptBox["x2", "6"]}], "+", "x3", "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "4"], " ", "x3"}], "+", 
      SuperscriptBox["x3", "2"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "4"], " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      SuperscriptBox["x3", "3"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "4"], " ", 
       SuperscriptBox["x3", "3"]}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "4"]}], "+", "x3", "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "4"], " ", "x3"}], "+", 
      SuperscriptBox["x3", "2"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "4"], " ", 
       SuperscriptBox["x3", "2"]}], "+", 
      SuperscriptBox["x3", "3"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "4"], " ", 
       SuperscriptBox["x3", "3"]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2", "+", "x1", "+", 
      SuperscriptBox["x1", "2"], "+", 
      SuperscriptBox["x1", "3"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "4"]}], "+", 
      SuperscriptBox["x2", "2"], "+", 
      RowBox[{"x1", " ", 
       SuperscriptBox["x2", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["x1", "2"], " ", 
       SuperscriptBox["x2", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["x1", "3"], " ", 
       SuperscriptBox["x2", "2"]}], "+", 
      RowBox[{"9223372036854775548", " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"], " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "3"], " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", "x1", " ", 
       SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "2"], " ", 
       SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "3"], " ", 
       SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
      SuperscriptBox["x3", "2"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x1", "4"], " ", 
       SuperscriptBox["x3", "2"]}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      SuperscriptBox["x2", "2"], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x3", "4"]}], "+", 
      RowBox[{"9223372036854775548", " ", 
       SuperscriptBox["x2", "2"], " ", 
       SuperscriptBox["x3", "4"]}]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.843788303988451*^9, 3.8437883287967033`*^9}, 
   3.8437884185357647`*^9, 3.8437969556529093`*^9, {3.843805532590103*^9, 
   3.843805544260631*^9}},
 CellLabel->"Out[35]=",ExpressionUUID->"e26050b1-3789-4a7f-bce7-752a2469ce0c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFReconstructFunction", "[", 
  RowBox[{"mygraph", ",", 
   RowBox[{"{", 
    RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}]}], "]"}]], "Code",
 CellLabel->"In[36]:=",ExpressionUUID->"93a47f08-76fd-434b-9264-9ce8e5e01185"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"2", "+", "x1", "-", 
     SuperscriptBox["x1", "2"], "-", 
     RowBox[{"x1", " ", "x2"}], "-", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", "x2"}], "+", 
     SuperscriptBox["x2", "2"], "+", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "2"]}], "-", 
     SuperscriptBox["x2", "3"], "-", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "3"]}], "+", "x3", "+", 
     RowBox[{"x1", " ", "x3"}], "-", 
     RowBox[{"x2", " ", "x3"}], "-", 
     RowBox[{"x1", " ", "x2", " ", "x3"}], "+", 
     RowBox[{
      SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "2"], " ", "x3"}], "-", 
     RowBox[{
      SuperscriptBox["x2", "3"], " ", "x3"}], "-", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "3"], " ", "x3"}], "+", 
     SuperscriptBox["x3", "2"], "-", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", 
      SuperscriptBox["x3", "2"]}], "+", 
     RowBox[{"x2", " ", 
      SuperscriptBox["x3", "2"]}], "-", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", "x2", " ", 
      SuperscriptBox["x3", "2"]}]}], 
    RowBox[{"1", "-", 
     SuperscriptBox["x2", "2"], "+", "x3", "-", 
     RowBox[{
      SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
     SuperscriptBox["x3", "2"], "-", 
     RowBox[{
      SuperscriptBox["x2", "2"], " ", 
      SuperscriptBox["x3", "2"]}], "+", 
     SuperscriptBox["x3", "3"], "-", 
     RowBox[{
      SuperscriptBox["x2", "2"], " ", 
      SuperscriptBox["x3", "3"]}]}]], ",", 
   FractionBox[
    RowBox[{"2", "+", "x1", "+", 
     SuperscriptBox["x1", "3"], "+", 
     RowBox[{"2", " ", "x2"}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["x1", "2"], " ", "x2"}], "+", 
     SuperscriptBox["x2", "2"], "-", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", 
      SuperscriptBox["x2", "2"]}], "+", "x3", "+", 
     RowBox[{"x1", " ", "x3"}], "+", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", "x3"}], "+", 
     RowBox[{
      SuperscriptBox["x1", "3"], " ", "x3"}], "-", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x3", "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["x1", "2"], " ", 
      SuperscriptBox["x3", "2"]}], "-", 
     RowBox[{
      SuperscriptBox["x1", "3"], " ", 
      SuperscriptBox["x3", "2"]}], "+", 
     RowBox[{"2", " ", "x2", " ", 
      SuperscriptBox["x3", "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["x1", "2"], " ", "x2", " ", 
      SuperscriptBox["x3", "2"]}], "+", 
     RowBox[{
      SuperscriptBox["x2", "2"], " ", 
      SuperscriptBox["x3", "2"]}], "-", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", 
      SuperscriptBox["x2", "2"], " ", 
      SuperscriptBox["x3", "2"]}], "-", 
     SuperscriptBox["x3", "3"], "-", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x3", "3"]}], "-", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", 
      SuperscriptBox["x3", "3"]}], "-", 
     RowBox[{
      SuperscriptBox["x1", "3"], " ", 
      SuperscriptBox["x3", "3"]}]}], 
    RowBox[{"1", "+", "x2", "+", "x3", "+", 
     RowBox[{"x2", " ", "x3"}], "-", 
     SuperscriptBox["x3", "4"], "-", 
     RowBox[{"x2", " ", 
      SuperscriptBox["x3", "4"]}], "-", 
     SuperscriptBox["x3", "5"], "-", 
     RowBox[{"x2", " ", 
      SuperscriptBox["x3", "5"]}]}]], ",", 
   FractionBox[
    RowBox[{"2", "+", "x1", "-", 
     SuperscriptBox["x1", "4"], "+", 
     SuperscriptBox["x2", "2"], "+", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "2"]}], "-", 
     SuperscriptBox["x2", "4"], "-", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "4"]}], "-", 
     SuperscriptBox["x2", "6"], "-", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "6"]}], "+", "x3", "-", 
     RowBox[{
      SuperscriptBox["x1", "4"], " ", "x3"}], "+", 
     SuperscriptBox["x3", "2"], "-", 
     RowBox[{
      SuperscriptBox["x1", "4"], " ", 
      SuperscriptBox["x3", "2"]}], "+", 
     SuperscriptBox["x3", "3"], "-", 
     RowBox[{
      SuperscriptBox["x1", "4"], " ", 
      SuperscriptBox["x3", "3"]}]}], 
    RowBox[{"1", "-", 
     SuperscriptBox["x2", "4"], "+", "x3", "-", 
     RowBox[{
      SuperscriptBox["x2", "4"], " ", "x3"}], "+", 
     SuperscriptBox["x3", "2"], "-", 
     RowBox[{
      SuperscriptBox["x2", "4"], " ", 
      SuperscriptBox["x3", "2"]}], "+", 
     SuperscriptBox["x3", "3"], "-", 
     RowBox[{
      SuperscriptBox["x2", "4"], " ", 
      SuperscriptBox["x3", "3"]}]}]], ",", 
   FractionBox[
    RowBox[{"2", "+", "x1", "+", 
     SuperscriptBox["x1", "2"], "+", 
     SuperscriptBox["x1", "3"], "-", 
     SuperscriptBox["x1", "4"], "+", 
     SuperscriptBox["x2", "2"], "+", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "2"]}], "+", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", 
      SuperscriptBox["x2", "2"]}], "+", 
     RowBox[{
      SuperscriptBox["x1", "3"], " ", 
      SuperscriptBox["x2", "2"]}], "-", "x3", "-", 
     RowBox[{"x1", " ", "x3"}], "-", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", "x3"}], "-", 
     RowBox[{
      SuperscriptBox["x1", "3"], " ", "x3"}], "-", 
     RowBox[{
      SuperscriptBox["x2", "2"], " ", "x3"}], "-", 
     RowBox[{"x1", " ", 
      SuperscriptBox["x2", "2"], " ", "x3"}], "-", 
     RowBox[{
      SuperscriptBox["x1", "2"], " ", 
      SuperscriptBox["x2", "2"], " ", "x3"}], "-", 
     RowBox[{
      SuperscriptBox["x1", "3"], " ", 
      SuperscriptBox["x2", "2"], " ", "x3"}], "+", 
     SuperscriptBox["x3", "2"], "-", 
     RowBox[{
      SuperscriptBox["x1", "4"], " ", 
      SuperscriptBox["x3", "2"]}]}], 
    RowBox[{"1", "+", 
     SuperscriptBox["x2", "2"], "-", 
     SuperscriptBox["x3", "4"], "-", 
     RowBox[{
      SuperscriptBox["x2", "2"], " ", 
      SuperscriptBox["x3", "4"]}]}]]}], "}"}]], "Output",
 CellChangeTimes->{3.84378826348339*^9, 3.843788422001504*^9, 
  3.8437969568367777`*^9, 3.843805559060976*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"2d617809-5371-4a04-b5fd-09a3701d70f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "FFReconstructFunction", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843788433611418*^9, 3.8437884375660067`*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"0f72c7f7-538a-4cb9-aacf-d3b238d15314"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"Checks\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"UChecks\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"MaxSingularPoints\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"StartingPrimeNo\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"MaxPrimes\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"MaxDegree\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"PrintDebugInfo\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"NThreads\"\>", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"\<\"MinPrimes\"\>", "\[Rule]", "1"}]}], "}"}]], "Output",
 CellChangeTimes->{3.843788437916234*^9, 3.843796958321591*^9, 
  3.84380556542463*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"31eddc80-7224-494b-9120-aa591af2fe71"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"FFDeleteGraph", "[", "mygraph", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843788467824914*^9, 3.84378847341002*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"0375657c-8304-4d20-bcca-f7116be71230"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Linear systems and learning algorithms", "Subsection",
 CellChangeTimes->{{3.843787346276639*^9, 3.843787358147668*^9}, 
   3.8437886476527233`*^9},ExpressionUUID->"965caeed-d183-49d5-8f27-\
ed566bbd2de9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"relations", "=", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["d", "3"], "+", 
          FractionBox[
           RowBox[{"2", " ", "d", " ", "x"}], "3"], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            SuperscriptBox["x", "2"]}], "3"], "+", 
          RowBox[{"x", " ", "y"}], "+", 
          SuperscriptBox["y", "2"], "+", 
          RowBox[{"d", " ", 
           SuperscriptBox["y", "2"]}]}], ",", 
         RowBox[{"1", "+", 
          FractionBox["d", "3"], "+", 
          SuperscriptBox["x", "2"], "+", "y", "+", 
          FractionBox[
           RowBox[{"x", " ", "y"}], "3"], "+", 
          RowBox[{"d", " ", "x", " ", "y"}], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            SuperscriptBox["y", "2"]}], "3"], "+", 
          FractionBox[
           RowBox[{"d", " ", 
            SuperscriptBox["y", "2"]}], "3"]}], ",", 
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{"2", " ", "d"}], "3"], "+", "x", "+", 
          RowBox[{"d", " ", 
           SuperscriptBox["x", "2"]}], "+", 
          RowBox[{"d", " ", "y"}], "+", 
          FractionBox[
           RowBox[{"x", " ", "y"}], "3"], "+", 
          FractionBox[
           RowBox[{"d", " ", "x", " ", "y"}], "3"], "+", 
          FractionBox[
           SuperscriptBox["y", "2"], "3"], "+", 
          FractionBox[
           RowBox[{"2", " ", "d", " ", 
            SuperscriptBox["y", "2"]}], "3"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], "+", 
          FractionBox["d", "6"], "+", 
          FractionBox["x", "2"], "+", 
          FractionBox[
           RowBox[{"d", " ", "x"}], "3"], "+", 
          FractionBox[
           RowBox[{"5", " ", 
            SuperscriptBox["x", "2"]}], "6"], "+", 
          RowBox[{"d", " ", 
           SuperscriptBox["x", "2"]}], "+", 
          FractionBox[
           RowBox[{"d", " ", "y"}], "2"], "-", 
          RowBox[{"x", " ", "y"}], "+", 
          FractionBox[
           RowBox[{"d", " ", "x", " ", "y"}], "2"], "-", 
          FractionBox[
           RowBox[{"d", " ", 
            SuperscriptBox["y", "2"]}], "2"]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], "-", 
          FractionBox["d", "3"], "+", 
          FractionBox["x", "2"], "+", 
          FractionBox[
           RowBox[{"3", " ", "d", " ", "x"}], "2"], "-", 
          FractionBox[
           SuperscriptBox["x", "2"], "2"], "+", 
          RowBox[{"d", " ", 
           SuperscriptBox["x", "2"]}], "-", 
          FractionBox["y", "2"], "+", 
          RowBox[{"d", " ", "y"}], "+", 
          FractionBox[
           RowBox[{"7", " ", "x", " ", "y"}], "6"], "-", 
          FractionBox[
           RowBox[{"d", " ", "x", " ", "y"}], "2"], "+", 
          FractionBox[
           SuperscriptBox["y", "2"], "3"], "+", 
          FractionBox[
           RowBox[{"7", " ", "d", " ", 
            SuperscriptBox["y", "2"]}], "6"]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], "-", 
          FractionBox["d", "6"], "-", 
          FractionBox["x", "2"], "+", 
          RowBox[{"d", " ", "x"}], "+", 
          SuperscriptBox["x", "2"], "+", 
          FractionBox["y", "2"], "+", 
          FractionBox[
           RowBox[{"d", " ", "y"}], "2"], "-", 
          FractionBox[
           RowBox[{"x", " ", "y"}], "3"], "+", 
          FractionBox[
           RowBox[{"2", " ", "d", " ", "x", " ", "y"}], "3"], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            SuperscriptBox["y", "2"]}], "3"], "+", 
          FractionBox[
           RowBox[{"5", " ", "d", " ", 
            SuperscriptBox["y", "2"]}], "6"]}]}], "}"}]}], "}"}], ".", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Int", "[", "1", "]"}], ",", 
       RowBox[{"Int", "[", "2", "]"}], ",", 
       RowBox[{"Int", "[", "3", "]"}]}], "}"}]}], "==", "0"}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843790854898142*^9, 3.843790954610393*^9}, {
  3.843791038280594*^9, 3.84379115394304*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"70d1c491-9bbe-4313-b7e5-e24b8ea220ea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["d", "3"], "+", 
        FractionBox[
         RowBox[{"2", " ", "d", " ", "x"}], "3"], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["x", "2"]}], "3"], "+", 
        RowBox[{"x", " ", "y"}], "+", 
        SuperscriptBox["y", "2"], "+", 
        RowBox[{"d", " ", 
         SuperscriptBox["y", "2"]}]}], ")"}], " ", 
      RowBox[{"Int", "[", "1", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        FractionBox["d", "3"], "+", 
        SuperscriptBox["x", "2"], "+", "y", "+", 
        FractionBox[
         RowBox[{"x", " ", "y"}], "3"], "+", 
        RowBox[{"d", " ", "x", " ", "y"}], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["y", "2"]}], "3"], "+", 
        FractionBox[
         RowBox[{"d", " ", 
          SuperscriptBox["y", "2"]}], "3"]}], ")"}], " ", 
      RowBox[{"Int", "[", "2", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{"2", " ", "d"}], "3"], "+", "x", "+", 
        RowBox[{"d", " ", 
         SuperscriptBox["x", "2"]}], "+", 
        RowBox[{"d", " ", "y"}], "+", 
        FractionBox[
         RowBox[{"x", " ", "y"}], "3"], "+", 
        FractionBox[
         RowBox[{"d", " ", "x", " ", "y"}], "3"], "+", 
        FractionBox[
         SuperscriptBox["y", "2"], "3"], "+", 
        FractionBox[
         RowBox[{"2", " ", "d", " ", 
          SuperscriptBox["y", "2"]}], "3"]}], ")"}], " ", 
      RowBox[{"Int", "[", "3", "]"}]}]}], "\[Equal]", "0"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", "2"], "+", 
        FractionBox["d", "6"], "+", 
        FractionBox["x", "2"], "+", 
        FractionBox[
         RowBox[{"d", " ", "x"}], "3"], "+", 
        FractionBox[
         RowBox[{"5", " ", 
          SuperscriptBox["x", "2"]}], "6"], "+", 
        RowBox[{"d", " ", 
         SuperscriptBox["x", "2"]}], "+", 
        FractionBox[
         RowBox[{"d", " ", "y"}], "2"], "-", 
        RowBox[{"x", " ", "y"}], "+", 
        FractionBox[
         RowBox[{"d", " ", "x", " ", "y"}], "2"], "-", 
        FractionBox[
         RowBox[{"d", " ", 
          SuperscriptBox["y", "2"]}], "2"]}], ")"}], " ", 
      RowBox[{"Int", "[", "1", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], "-", 
        FractionBox["d", "3"], "+", 
        FractionBox["x", "2"], "+", 
        FractionBox[
         RowBox[{"3", " ", "d", " ", "x"}], "2"], "-", 
        FractionBox[
         SuperscriptBox["x", "2"], "2"], "+", 
        RowBox[{"d", " ", 
         SuperscriptBox["x", "2"]}], "-", 
        FractionBox["y", "2"], "+", 
        RowBox[{"d", " ", "y"}], "+", 
        FractionBox[
         RowBox[{"7", " ", "x", " ", "y"}], "6"], "-", 
        FractionBox[
         RowBox[{"d", " ", "x", " ", "y"}], "2"], "+", 
        FractionBox[
         SuperscriptBox["y", "2"], "3"], "+", 
        FractionBox[
         RowBox[{"7", " ", "d", " ", 
          SuperscriptBox["y", "2"]}], "6"]}], ")"}], " ", 
      RowBox[{"Int", "[", "2", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], "-", 
        FractionBox["d", "6"], "-", 
        FractionBox["x", "2"], "+", 
        RowBox[{"d", " ", "x"}], "+", 
        SuperscriptBox["x", "2"], "+", 
        FractionBox["y", "2"], "+", 
        FractionBox[
         RowBox[{"d", " ", "y"}], "2"], "-", 
        FractionBox[
         RowBox[{"x", " ", "y"}], "3"], "+", 
        FractionBox[
         RowBox[{"2", " ", "d", " ", "x", " ", "y"}], "3"], "+", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["y", "2"]}], "3"], "+", 
        FractionBox[
         RowBox[{"5", " ", "d", " ", 
          SuperscriptBox["y", "2"]}], "6"]}], ")"}], " ", 
      RowBox[{"Int", "[", "3", "]"}]}]}], "\[Equal]", "0"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.843791114321918*^9, 3.843791154265173*^9}, 
   3.8437915416236887`*^9, 3.843796961032174*^9, 3.843805652756858*^9},
 CellLabel->"Out[39]=",ExpressionUUID->"eec33f38-bc64-4263-9cba-bb19a87af410"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FFNewGraph", "[", "mygraph", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"FFGraphInputVars", "[", 
   RowBox[{"mygraph", ",", " ", "in", ",", " ", 
    RowBox[{"{", 
     RowBox[{"d", ",", "x", ",", "y"}], "}"}]}], "]"}], ";"}]}], "Code",
 CellChangeTimes->{{3.8437911705502357`*^9, 3.8437912075569477`*^9}, 
   3.8437912789688587`*^9},
 CellLabel->"In[40]:=",ExpressionUUID->"0c1757c3-ca98-46e6-81c9-51d9f466e542"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"variables", " ", "in", " ", "the", " ", 
    RowBox[{"system", ".", " ", "the"}], " ", "ordering", " ", "is", " ", 
    RowBox[{"important", "."}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"all", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Int", "[", "#", "]"}], "&"}], "/@", 
    RowBox[{"Range", "[", "3", "]"}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.843791210385425*^9, 3.843791231381913*^9}, {
  3.843791335109097*^9, 3.843791347856997*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"1788ac1e-86d9-430a-9124-f703ae07a8ac"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Int", "[", "1", "]"}], ",", 
   RowBox[{"Int", "[", "2", "]"}], ",", 
   RowBox[{"Int", "[", "3", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.8437912317123613`*^9, 3.8437969626935863`*^9, 
  3.8438057020174103`*^9},
 CellLabel->"Out[42]=",ExpressionUUID->"6757076f-4fa8-49e0-a845-0334be400970"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"define", " ", "a", " ", "sparsesolver", " ", "algorithm"}], 
   "*)"}], "\n", 
  RowBox[{
   RowBox[{"FFAlgSparseSolver", "[", 
    RowBox[{"mygraph", ",", " ", "sys", ",", " ", 
     RowBox[{"{", "in", "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"d", ",", "x", ",", "y"}], "}"}], ",", " ", "relations", ",", 
     " ", "all", ",", " ", 
     RowBox[{"\"\<NeededVars\>\"", " ", "->", " ", "all"}]}], "]"}], 
   ";"}]}]], "Code",
 CellChangeTimes->{{3.8437911705502357`*^9, 3.8437912075569477`*^9}, {
  3.843791246365959*^9, 3.8437912818460493`*^9}, {3.843791316846713*^9, 
  3.8437913232082453`*^9}, {3.843791562008654*^9, 3.843791572847787*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"393ba01e-c90a-45fb-a77b-30b4a03ac1bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"We", " ", 
     RowBox[{"don", "'"}], "t", " ", "want", " ", "the", " ", "constant", " ",
      "term", " ", "in", " ", "the", " ", "solution", " ", 
     RowBox[{"(", 
      RowBox[{"which", " ", "is", " ", "zero"}], ")"}]}], ",", " ", 
    RowBox[{"so", " ", "we", " ", "exclude", " ", "it", " ", "with"}]}], 
   "*)"}], "\n", 
  RowBox[{
   RowBox[{"FFSolverOnlyHomogeneous", "[", 
    RowBox[{"mygraph", ",", " ", "sys"}], "]"}], ";"}]}]], "Code",
 CellChangeTimes->{{3.8437911705502357`*^9, 3.8437912075569477`*^9}, {
  3.843791246365959*^9, 3.8437912818460493`*^9}, {3.843791316846713*^9, 
  3.8437913232082453`*^9}, {3.843791357744996*^9, 3.843791358670924*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"3ab1a6b4-2563-4fac-9904-f865b5edc598"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FFGraphOutput", "[", 
   RowBox[{"mygraph", ",", " ", "sys"}], "]"}], ";"}]], "Code",
 CellChangeTimes->{{3.8437911705502357`*^9, 3.8437912075569477`*^9}, {
  3.843791246365959*^9, 3.8437912818460493`*^9}, {3.843791316846713*^9, 
  3.8437913232082453`*^9}, {3.843791357744996*^9, 3.843791386811508*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"ce283ccb-7f69-443d-94e3-7489af92d403"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "A", "  ", "linear", " ", "solver", " ", "needs", " ", "to", " ", 
     "complete", " ", "a", " ", "learning", " ", "phase"}], ",", " ", 
    RowBox[{
    "where", " ", "it", " ", "learns", " ", "the", " ", "dependent", " ", 
     "variables"}], ",", " ", 
    RowBox[{"independent", " ", "variables"}], ",", " ", 
    RowBox[{
     RowBox[{"etc", "..."}], "   ", "Before", " ", "this", " ", "is", " ", 
     "completed"}], ",", " ", 
    RowBox[{"the", " ", "node", " ", "cannot", " ", "be", " ", 
     RowBox[{"evaluated", "."}]}]}], "*)"}], "\n", 
  RowBox[{"learn", " ", "=", " ", 
   RowBox[{"FFSparseSolverLearn", "[", 
    RowBox[{"mygraph", ",", " ", "all"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.8437911705502357`*^9, 3.8437912075569477`*^9}, {
  3.843791246365959*^9, 3.8437912818460493`*^9}, {3.843791316846713*^9, 
  3.8437913232082453`*^9}, {3.843791357744996*^9, 3.8437913928949423`*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"57993f43-bc82-4e82-9709-966a7a4e50a0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"DepVars\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Int", "[", "1", "]"}], ",", 
      RowBox[{"Int", "[", "2", "]"}]}], "}"}]}], ",", 
   RowBox[{"\<\"IndepVars\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Int", "[", "3", "]"}], "}"}]}], ",", 
   RowBox[{"\<\"SparseOutput\"\>", "\[Rule]", "False"}]}], "}"}]], "Output",
 CellChangeTimes->{3.843791393488965*^9, 3.843796965671163*^9, 
  3.843805853811572*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"be4beac3-53bf-47e4-a6a7-2c7d5a4b55ea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFReconstructFunction", "[", 
  RowBox[{"mygraph", ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "x", ",", "y"}], "}"}]}], "]"}]], "Code",
 CellChangeTimes->{{3.843791447323421*^9, 3.843791452804406*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"9c80d89c-1ac4-4b60-a40d-9155899c9521"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "d"}], "3"]}], "-", 
      FractionBox[
       SuperscriptBox["d", "2"], "3"], "+", "x", "+", 
      FractionBox[
       RowBox[{"4", " ", "d", " ", "x"}], "3"], "+", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["d", "2"], " ", "x"}], "3"], "-", 
      SuperscriptBox["x", "2"], "+", 
      RowBox[{"3", " ", "d", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["x", "2"]}], "3"], "+", 
      RowBox[{"d", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"d", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "4"]}], "-", "y", "-", 
      FractionBox[
       RowBox[{"2", " ", "d", " ", "y"}], "3"], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", "y"}], "3"], "+", 
      RowBox[{"3", " ", "x", " ", "y"}], "+", 
      RowBox[{"d", " ", "x", " ", "y"}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", "y"}], "-", 
      RowBox[{
       FractionBox["7", "3"], " ", "d", " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["x", "3"], " ", "y"}], "3"], "-", 
      RowBox[{
       FractionBox["2", "3"], " ", "d", " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "-", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "-", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      FractionBox[
       RowBox[{"5", " ", "d", " ", 
        SuperscriptBox["y", "2"]}], "3"], "+", 
      FractionBox[
       RowBox[{"8", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "2"]}], "3"], "+", 
      FractionBox[
       RowBox[{"5", " ", "x", " ", 
        SuperscriptBox["y", "2"]}], "3"], "+", 
      RowBox[{"3", " ", "d", " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{"d", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      FractionBox[
       RowBox[{"7", " ", 
        SuperscriptBox["y", "3"]}], "3"], "-", 
      RowBox[{"2", " ", "d", " ", 
       SuperscriptBox["y", "3"]}], "+", 
      FractionBox[
       RowBox[{"10", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "3"]}], "3"], "+", 
      RowBox[{"x", " ", 
       SuperscriptBox["y", "3"]}], "-", 
      RowBox[{
       FractionBox["1", "3"], " ", "d", " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "-", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox["y", "4"]}], "3"], "-", 
      FractionBox[
       RowBox[{"d", " ", 
        SuperscriptBox["y", "4"]}], "3"], "+", 
      RowBox[{
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["y", "4"]}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", "d", "+", 
      FractionBox[
       SuperscriptBox["d", "2"], "3"], "+", "x", "+", 
      FractionBox[
       RowBox[{"4", " ", "d", " ", "x"}], "3"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", "x"}], "3"], "+", 
      FractionBox[
       RowBox[{"10", " ", 
        SuperscriptBox["x", "2"]}], "3"], "+", 
      RowBox[{"3", " ", "d", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"]}], "+", 
      FractionBox[
       SuperscriptBox["x", "3"], "3"], "-", 
      FractionBox[
       RowBox[{"2", " ", "d", " ", 
        SuperscriptBox["x", "3"]}], "3"], "-", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["x", "3"]}], "3"], "+", 
      FractionBox[
       RowBox[{"7", " ", 
        SuperscriptBox["x", "4"]}], "3"], "+", 
      FractionBox[
       RowBox[{"2", " ", "d", " ", 
        SuperscriptBox["x", "4"]}], "3"], "+", "y", "+", 
      FractionBox[
       RowBox[{"5", " ", "d", " ", "y"}], "3"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", "y"}], "3"], "+", 
      FractionBox[
       RowBox[{"x", " ", "y"}], "3"], "+", 
      FractionBox[
       RowBox[{"8", " ", "d", " ", "x", " ", "y"}], "3"], "-", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", "y"}], "+", 
      FractionBox[
       RowBox[{"5", " ", 
        SuperscriptBox["x", "2"], " ", "y"}], "3"], "-", 
      RowBox[{
       FractionBox["5", "3"], " ", "d", " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "+", 
      RowBox[{
       FractionBox["4", "3"], " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "+", 
      RowBox[{"2", " ", "d", " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "+", 
      FractionBox[
       RowBox[{"5", " ", 
        SuperscriptBox["y", "2"]}], "3"], "+", 
      RowBox[{"2", " ", "d", " ", 
       SuperscriptBox["y", "2"]}], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      FractionBox[
       RowBox[{"4", " ", "x", " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      RowBox[{
       FractionBox["13", "3"], " ", "d", " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{
       FractionBox["10", "3"], " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "-", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["x", "2"], " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      RowBox[{
       FractionBox["7", "3"], " ", "d", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "+", 
      SuperscriptBox["y", "3"], "-", 
      FractionBox[
       RowBox[{"4", " ", "d", " ", 
        SuperscriptBox["y", "3"]}], "3"], "-", 
      FractionBox[
       RowBox[{"5", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "3"]}], "3"], "-", 
      FractionBox[
       RowBox[{"13", " ", "x", " ", 
        SuperscriptBox["y", "3"]}], "3"], "-", 
      RowBox[{"4", " ", "d", " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "-", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox["y", "4"]}], "3"], "-", 
      FractionBox[
       RowBox[{"11", " ", "d", " ", 
        SuperscriptBox["y", "4"]}], "3"], "-", 
      FractionBox[
       RowBox[{"8", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "4"]}], "3"]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      FractionBox[
       RowBox[{"4", " ", "d"}], "3"], "-", 
      FractionBox[
       SuperscriptBox["d", "2"], "3"], "-", 
      RowBox[{"2", " ", "x"}], "-", 
      FractionBox[
       RowBox[{"8", " ", "d", " ", "x"}], "3"], "-", 
      FractionBox[
       RowBox[{"10", " ", 
        SuperscriptBox["x", "2"]}], "3"], "-", 
      RowBox[{"5", " ", "d", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["x", "2"]}], "3"], "-", 
      FractionBox[
       RowBox[{"7", " ", 
        SuperscriptBox["x", "3"]}], "3"], "-", 
      FractionBox[
       RowBox[{"d", " ", 
        SuperscriptBox["x", "3"]}], "3"], "-", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["x", "3"]}], "3"], "+", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["x", "4"]}], "3"], "-", 
      FractionBox[
       RowBox[{"5", " ", "d", " ", 
        SuperscriptBox["x", "4"]}], "3"], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "4"]}], "-", 
      FractionBox[
       RowBox[{"5", " ", "d", " ", "y"}], "3"], "-", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox["d", "2"], " ", "y"}], "3"], "+", 
      FractionBox[
       RowBox[{"2", " ", "x", " ", "y"}], "3"], "-", 
      RowBox[{"2", " ", "d", " ", "x", " ", "y"}], "-", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", "y"}], "+", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["x", "2"], " ", "y"}], "3"], "-", 
      RowBox[{"d", " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "-", 
      RowBox[{
       FractionBox["7", "3"], " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "+", 
      RowBox[{
       SuperscriptBox["x", "3"], " ", "y"}], "+", 
      RowBox[{
       FractionBox["5", "3"], " ", "d", " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "-", 
      RowBox[{
       FractionBox["5", "3"], " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "-", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      FractionBox[
       RowBox[{"2", " ", "d", " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      FractionBox[
       RowBox[{"x", " ", 
        SuperscriptBox["y", "2"]}], "3"], "+", 
      RowBox[{
       FractionBox["14", "3"], " ", "d", " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "+", 
      RowBox[{
       FractionBox["4", "3"], " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "+", 
      FractionBox[
       RowBox[{"7", " ", 
        SuperscriptBox["x", "2"], " ", 
        SuperscriptBox["y", "2"]}], "3"], "+", 
      RowBox[{"3", " ", "d", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{
       FractionBox["2", "3"], " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "+", 
      SuperscriptBox["y", "3"], "+", 
      FractionBox[
       RowBox[{"5", " ", "d", " ", 
        SuperscriptBox["y", "3"]}], "3"], "+", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "3"]}], "3"], "+", 
      FractionBox[
       RowBox[{"4", " ", "x", " ", 
        SuperscriptBox["y", "3"]}], "3"], "+", 
      RowBox[{
       FractionBox["11", "3"], " ", "d", " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{
       SuperscriptBox["d", "2"], " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "+", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["y", "4"]}], "3"], "+", 
      FractionBox[
       RowBox[{"10", " ", "d", " ", 
        SuperscriptBox["y", "4"]}], "3"], "+", 
      FractionBox[
       RowBox[{"7", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "4"]}], "3"]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", "d", "+", 
      FractionBox[
       SuperscriptBox["d", "2"], "3"], "+", "x", "+", 
      FractionBox[
       RowBox[{"4", " ", "d", " ", "x"}], "3"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", "x"}], "3"], "+", 
      FractionBox[
       RowBox[{"10", " ", 
        SuperscriptBox["x", "2"]}], "3"], "+", 
      RowBox[{"3", " ", "d", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"]}], "+", 
      FractionBox[
       SuperscriptBox["x", "3"], "3"], "-", 
      FractionBox[
       RowBox[{"2", " ", "d", " ", 
        SuperscriptBox["x", "3"]}], "3"], "-", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["x", "3"]}], "3"], "+", 
      FractionBox[
       RowBox[{"7", " ", 
        SuperscriptBox["x", "4"]}], "3"], "+", 
      FractionBox[
       RowBox[{"2", " ", "d", " ", 
        SuperscriptBox["x", "4"]}], "3"], "+", "y", "+", 
      FractionBox[
       RowBox[{"5", " ", "d", " ", "y"}], "3"], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", "y"}], "3"], "+", 
      FractionBox[
       RowBox[{"x", " ", "y"}], "3"], "+", 
      FractionBox[
       RowBox[{"8", " ", "d", " ", "x", " ", "y"}], "3"], "-", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", "y"}], "+", 
      FractionBox[
       RowBox[{"5", " ", 
        SuperscriptBox["x", "2"], " ", "y"}], "3"], "-", 
      RowBox[{
       FractionBox["5", "3"], " ", "d", " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "+", 
      RowBox[{
       FractionBox["4", "3"], " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "+", 
      RowBox[{"2", " ", "d", " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "+", 
      FractionBox[
       RowBox[{"5", " ", 
        SuperscriptBox["y", "2"]}], "3"], "+", 
      RowBox[{"2", " ", "d", " ", 
       SuperscriptBox["y", "2"]}], "-", 
      FractionBox[
       RowBox[{
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      FractionBox[
       RowBox[{"4", " ", "x", " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      RowBox[{
       FractionBox["13", "3"], " ", "d", " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{
       FractionBox["10", "3"], " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "-", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["x", "2"], " ", 
        SuperscriptBox["y", "2"]}], "3"], "-", 
      RowBox[{
       FractionBox["7", "3"], " ", "d", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       SuperscriptBox["d", "2"], " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "2"]}], "+", 
      SuperscriptBox["y", "3"], "-", 
      FractionBox[
       RowBox[{"4", " ", "d", " ", 
        SuperscriptBox["y", "3"]}], "3"], "-", 
      FractionBox[
       RowBox[{"5", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "3"]}], "3"], "-", 
      FractionBox[
       RowBox[{"13", " ", "x", " ", 
        SuperscriptBox["y", "3"]}], "3"], "-", 
      RowBox[{"4", " ", "d", " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{
       FractionBox["1", "3"], " ", 
       SuperscriptBox["d", "2"], " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "-", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox["y", "4"]}], "3"], "-", 
      FractionBox[
       RowBox[{"11", " ", "d", " ", 
        SuperscriptBox["y", "4"]}], "3"], "-", 
      FractionBox[
       RowBox[{"8", " ", 
        SuperscriptBox["d", "2"], " ", 
        SuperscriptBox["y", "4"]}], "3"]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.843788914033936*^9, 3.843791453295209*^9, 
  3.843796966590953*^9, 3.843805876512031*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"dc804e11-a56d-4249-bf6f-181da3ea61c0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"FFDeleteGraph", "[", "mygraph", "]"}]], "Code",
 CellLabel->"In[49]:=",ExpressionUUID->"e1946354-dc73-46e7-b1fe-fc661207ae52"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Subgraphs", "Subsection"],
 "\t"
}], "Subsection",ExpressionUUID->"91c513ea-1b2f-4335-8c2a-43b0348e6102"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Laurent", " ", "series", " ", "expansion", " ", "algorithm"}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.843789086117392*^9, 
  3.8437890895430317`*^9}},ExpressionUUID->"20c04dc9-9070-442d-9164-\
22294180eb99"],

Cell["\<\
In this section we introduce subgraph nodes.  In particular, we focus on the \
Laurent series expansion algorithm.\
\>", "Text",ExpressionUUID->"926c0cb7-bc06-495d-a2c0-fffbe161a48b"],

Cell["\<\
We define a first graph g1 depending on three variables.  To make things \
simple, we just define a list of rational functions, but it could be any \
other arbitrarily complicated graph, whose output may not be known \
analytically.\
\>", "Text",ExpressionUUID->"6f21ef10-9248-47b2-bc8c-854aa2e33967"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"FFNewGraph", "[", 
   RowBox[{"g1", ",", "input", ",", 
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}]}], "]"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"FFAlgRatFunEval", "[", 
   RowBox[{"g1", ",", "functions", ",", 
    RowBox[{"{", "input", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"x1", " ", 
          RowBox[{"x2", "^", "2"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"x1", "+", 
         RowBox[{"x1", " ", 
          RowBox[{"x3", "^", "2"}]}]}], ")"}]}], ",", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"x1", "^", "2"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"x1", "+", 
         RowBox[{
          RowBox[{"x1", "^", "2"}], " ", 
          RowBox[{"x3", "^", "2"}]}]}], ")"}]}], ",", " ", 
      RowBox[{"x1", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"x1", "^", "2"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"x1", " ", 
           RowBox[{"x2", "^", "2"}]}]}], ")"}]}]}], ",", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"x1", "^", "2"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"x1", "-", 
         RowBox[{"x3", "^", "2"}]}], ")"}]}]}], "}"}]}], "]"}], 
  "\n"}], "\n", 
 RowBox[{"FFGraphOutput", "[", 
  RowBox[{"g1", ",", "functions"}], "]"}]}], "Code",
 CellLabel->"In[50]:=",ExpressionUUID->"262433be-afb8-4b0e-8cfc-47c661420234"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.8437967255060997`*^9, 3.843796974055764*^9, 
  3.8438059471417627`*^9},
 CellLabel->"Out[50]=",ExpressionUUID->"df6c6037-0bc5-4e16-bd94-ef3eb781f774"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.8437967255060997`*^9, 3.843796974055764*^9, 
  3.8438059471427937`*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"aa037541-f76b-4431-93aa-7ec26507b0b1"]
}, Open  ]],

Cell["\<\
We now want to define a graph g2 which computes the Laurent expansion of g1 \
with respect to x1 (which must be the first input variable of g1) up to (and \
including) x^order terms, where order can be any positive, zero, or negative \
integer, say\
\>", "Text",ExpressionUUID->"736039d9-1fe2-47a5-bec7-7be1b0846722"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"order", "=", "3"}]], "Code",
 CellLabel->"In[53]:=",ExpressionUUID->"64bef1af-bece-4126-8a30-dea8d6b17423"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{3.8437967277904367`*^9, 3.843796975252058*^9, 
  3.84380596321246*^9},
 CellLabel->"Out[53]=",ExpressionUUID->"fce20ed7-1e10-465b-8cff-24d0eefdbdc1"]
}, Open  ]],

Cell["\<\
The coefficients of the Laurent expansion will be rational functions of x2 \
and x3.\
\>", "Text",ExpressionUUID->"a4ce4c3b-e5ed-469c-b213-f3976cd12d95"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFNewGraph", "[", 
  RowBox[{"g2", ",", "input", ",", 
   RowBox[{"{", 
    RowBox[{"x2", ",", "x3"}], "}"}]}], "]"}]], "Code",
 CellLabel->"In[54]:=",ExpressionUUID->"6661428e-9a3f-4056-b9c3-923cd8afcd78"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.843796732656472*^9, 3.8437969762578287`*^9, 
  3.843805967288267*^9},
 CellLabel->"Out[54]=",ExpressionUUID->"902343cd-e2ba-4c3a-932c-f322f71af35e"]
}, Open  ]],

Cell["\<\
We define the node in g2 which computes the Laurent expansion up to the \
selected order, taking g1 as subgraph.\
\>", "Text",ExpressionUUID->"59e22b11-d8d6-4e7b-b185-2ce3c8b17dd7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFAlgLaurent", "[", 
  RowBox[{"g2", ",", "laurent", ",", 
   RowBox[{"{", "input", "}"}], ",", "g1", ",", "order"}], "]"}]], "Code",
 CellLabel->"In[55]:=",ExpressionUUID->"383f7ef5-703f-4d0c-b16b-7509bbb84d6e"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.843796749539415*^9, 3.843796977177157*^9, 
  3.843805996009199*^9},
 CellLabel->"Out[55]=",ExpressionUUID->"0ed98ed1-9b67-462d-8f7e-827aa4d189b4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"FFGraphOutput", "[", 
  RowBox[{"g2", ",", "laurent"}], "]"}]], "Code",
 CellLabel->"In[56]:=",ExpressionUUID->"fe8bc84c-9722-4eea-9b5e-342e707c6864"],

Cell["\<\
Laurent expansion algorithms need a learning phase, where the starting order \
of the expansion and other information is obtained.\
\>", "Text",ExpressionUUID->"a5fb657a-9e80-4f8b-9148-3ebf7822539e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFGraphDraw", "[", "g2", "]"}]], "Input",
 CellChangeTimes->{{3.8438060094424343`*^9, 3.843806013026709*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"09d526ac-74a7-4dcd-a1eb-d71373cfbb73"],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[Medium], 
    ArrowBox[{{0., 1.}, {0., 0.}}, 0.01273]}, 
   {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
    0.7]}], {DiskBox[{0., 1.}, 0.01273], 
     InsetBox["input", Offset[{2, 2}, {0.01273, 1.01273}], ImageScaled[{0, 0}],
      BaseStyle->"Graphics"]}, {DiskBox[{0., 0.}, 0.01273], 
     InsetBox["laurent", Offset[{2, 2}, {0.01273, 0.01273}], ImageScaled[{0, 0}],
      BaseStyle->"Graphics"]}}},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.843806013903716*^9},
 CellLabel->"Out[58]=",ExpressionUUID->"17fb4baf-2283-4895-87e2-df407bbb96fe"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFGraphDraw", "[", "g1", "]"}]], "Input",
 CellChangeTimes->{{3.843806019852323*^9, 3.843806022697361*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"225b0fc6-5ee1-4b69-ab7b-e7885aae12d6"],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[Medium], 
    ArrowBox[{{0., 1.}, {0., 0.}}, 0.01273]}, 
   {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
    0.7]}], {DiskBox[{0., 1.}, 0.01273], 
     InsetBox["input", Offset[{2, 2}, {0.01273, 1.01273}], ImageScaled[{0, 0}],
      BaseStyle->"Graphics"]}, {DiskBox[{0., 0.}, 0.01273], 
     InsetBox["functions", Offset[{2, 2}, {0.01273, 0.01273}], ImageScaled[{0, 0}],
      BaseStyle->"Graphics"]}}},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.843806023150638*^9},
 CellLabel->"Out[59]=",ExpressionUUID->"76cecc1d-1335-4dfe-a9df-661dbdd7c699"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"laurentlearn", " ", "=", " ", 
  RowBox[{"FFLaurentLearn", "[", "g2", "]"}]}]], "Code",
 CellLabel->"In[60]:=",ExpressionUUID->"456ff4e7-2851-49f0-b8c7-c8fe8946d110"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.843796753188045*^9, 3.8437969797400513`*^9, 
  3.843806004680294*^9, 3.843806046598983*^9},
 CellLabel->"Out[60]=",ExpressionUUID->"100cfe13-026b-41f6-a22d-58bdd188dab7"]
}, Open  ]],

Cell["\<\
Notice that we can get the general form of the expansion, in terms of generic \
coefficients,\
\>", "Text",ExpressionUUID->"ac568cfe-d7d8-4436-a353-8322926d8405"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"coefficients", " ", "=", " ", 
  RowBox[{"coeff", "/@", 
   RowBox[{"Range", "[", 
    RowBox[{"FFNParsOut", "[", 
     RowBox[{"g2", ",", "laurent"}], "]"}], "]"}]}]}]], "Code",
 CellLabel->"In[55]:=",ExpressionUUID->"391fbc11-a5a1-4158-9d4b-daf2e777922e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"coeff", "[", "1", "]"}], ",", 
   RowBox[{"coeff", "[", "2", "]"}], ",", 
   RowBox[{"coeff", "[", "3", "]"}], ",", 
   RowBox[{"coeff", "[", "4", "]"}], ",", 
   RowBox[{"coeff", "[", "5", "]"}], ",", 
   RowBox[{"coeff", "[", "6", "]"}], ",", 
   RowBox[{"coeff", "[", "7", "]"}], ",", 
   RowBox[{"coeff", "[", "8", "]"}], ",", 
   RowBox[{"coeff", "[", "9", "]"}], ",", 
   RowBox[{"coeff", "[", "10", "]"}], ",", 
   RowBox[{"coeff", "[", "11", "]"}], ",", 
   RowBox[{"coeff", "[", "12", "]"}], ",", 
   RowBox[{"coeff", "[", "13", "]"}], ",", 
   RowBox[{"coeff", "[", "14", "]"}], ",", 
   RowBox[{"coeff", "[", "15", "]"}], ",", 
   RowBox[{"coeff", "[", "16", "]"}], ",", 
   RowBox[{"coeff", "[", "17", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.843796760258973*^9, 3.8437969807858067`*^9},
 CellLabel->"Out[55]=",ExpressionUUID->"f5ee59b7-94af-4cca-8dca-2a34c7741c3b"]
}, Open  ]],

Cell["\<\
based on the information we already learned, and without doing any \
reconstruction.\
\>", "Text",
 CellChangeTimes->{{3.843796981495467*^9, 
  3.8437969889933453`*^9}},ExpressionUUID->"68218cb9-b661-4010-8bd5-\
2f7c772dcda4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFLaurentSol", "[", 
  RowBox[{"coefficients", ",", "x1", ",", "laurentlearn"}], "]"}]], "Code",
 CellLabel->"In[56]:=",ExpressionUUID->"ffd36146-c460-41d3-8f1f-7e39b75e9dcf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    RowBox[{
     FractionBox[
      RowBox[{"coeff", "[", "1", "]"}], "x1"], "+", 
     RowBox[{"coeff", "[", "2", "]"}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "3", "]"}], " ", "x1"}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "4", "]"}], " ", 
      SuperscriptBox["x1", "2"]}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "5", "]"}], " ", 
      SuperscriptBox["x1", "3"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "x1", "]"}], "4"],
      SeriesData[$CellContext`x1, 0, {}, -1, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`x1, 0, {
      $CellContext`coeff[1], 
      $CellContext`coeff[2], 
      $CellContext`coeff[3], 
      $CellContext`coeff[4], 
      $CellContext`coeff[5]}, -1, 4, 1],
    Editable->False], ",", 
   InterpretationBox[
    RowBox[{
     FractionBox[
      RowBox[{"coeff", "[", "6", "]"}], "x1"], "+", 
     RowBox[{"coeff", "[", "7", "]"}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "8", "]"}], " ", "x1"}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "9", "]"}], " ", 
      SuperscriptBox["x1", "2"]}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "10", "]"}], " ", 
      SuperscriptBox["x1", "3"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "x1", "]"}], "4"],
      SeriesData[$CellContext`x1, 0, {}, -1, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`x1, 0, {
      $CellContext`coeff[6], 
      $CellContext`coeff[7], 
      $CellContext`coeff[8], 
      $CellContext`coeff[9], 
      $CellContext`coeff[10]}, -1, 4, 1],
    Editable->False], ",", 
   InterpretationBox[
    RowBox[{
     RowBox[{
      RowBox[{"coeff", "[", "11", "]"}], " ", "x1"}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "12", "]"}], " ", 
      SuperscriptBox["x1", "2"]}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "13", "]"}], " ", 
      SuperscriptBox["x1", "3"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "x1", "]"}], "4"],
      SeriesData[$CellContext`x1, 0, {}, 1, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`x1, 0, {
      $CellContext`coeff[11], 
      $CellContext`coeff[12], 
      $CellContext`coeff[13]}, 1, 4, 1],
    Editable->False], ",", 
   InterpretationBox[
    RowBox[{
     RowBox[{"coeff", "[", "14", "]"}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "15", "]"}], " ", "x1"}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "16", "]"}], " ", 
      SuperscriptBox["x1", "2"]}], "+", 
     RowBox[{
      RowBox[{"coeff", "[", "17", "]"}], " ", 
      SuperscriptBox["x1", "3"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "x1", "]"}], "4"],
      SeriesData[$CellContext`x1, 0, {}, 0, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`x1, 0, {
      $CellContext`coeff[14], 
      $CellContext`coeff[15], 
      $CellContext`coeff[16], 
      $CellContext`coeff[17]}, 0, 4, 1],
    Editable->False]}], "}"}]], "Output",
 CellChangeTimes->{3.843796793111989*^9, 3.84379698985007*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"b36ec1c9-206f-451d-ae7a-af37296733e8"]
}, Open  ]],

Cell["\<\
The coefficients of the Laurent expansion can be computed numerically and \
reconstructed.  \
\>", "Text",ExpressionUUID->"f2464fa8-0227-4f91-bb40-39e3fa9de59a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"reconstructed", "=", 
  RowBox[{"FFReconstructFunction", "[", 
   RowBox[{"g2", ",", 
    RowBox[{"{", 
     RowBox[{"x2", ",", "x3"}], "}"}]}], "]"}]}]], "Code",
 CellLabel->"In[61]:=",ExpressionUUID->"fb3e9e3f-5548-45b3-a148-97dd817c485c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"1", "+", 
     SuperscriptBox["x3", "2"]}]], ",", 
   FractionBox[
    SuperscriptBox["x2", "2"], 
    RowBox[{"1", "+", 
     SuperscriptBox["x3", "2"]}]], ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", 
   RowBox[{"-", 
    SuperscriptBox["x3", "2"]}], ",", 
   RowBox[{"1", "+", 
    SuperscriptBox["x3", "4"]}], ",", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox["x3", "2"]}], "-", 
    SuperscriptBox["x3", "6"]}], ",", 
   RowBox[{
    SuperscriptBox["x3", "4"], "+", 
    SuperscriptBox["x3", "8"]}], ",", "1", ",", 
   SuperscriptBox["x2", "2"], ",", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    SuperscriptBox["x2", "4"]}], ",", 
   RowBox[{"-", 
    FractionBox["1", 
     SuperscriptBox["x3", "2"]]}], ",", 
   RowBox[{"-", 
    FractionBox["1", 
     SuperscriptBox["x3", "4"]]}], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["x3", "4"]}], 
    SuperscriptBox["x3", "6"]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["x3", "4"]}], 
    SuperscriptBox["x3", "8"]]}], "}"}]], "Output",
 CellChangeTimes->{3.843796788454962*^9, 3.843796991135969*^9, 
  3.843806057666647*^9},
 CellLabel->"Out[61]=",ExpressionUUID->"d678e14c-28b8-4464-a832-991ab6edf59f"]
}, Open  ]],

Cell["\<\
From the reconstructed coefficients we can explicitly build the analytic \
Laurent expansion using the FFLaurentSol utility\
\>", "Text",ExpressionUUID->"fe8d129f-8f33-42df-b3af-b2ce2658aefe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FFLaurentSol", "[", 
  RowBox[{"reconstructed", ",", "x1", ",", "laurentlearn"}], "]"}]], "Code",
 CellLabel->"In[62]:=",ExpressionUUID->"c4aa51eb-cef7-468f-b573-cf739901b602"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    RowBox[{
     FractionBox["1", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["x3", "2"]}], ")"}], " ", "x1"}]], "+", 
     FractionBox[
      SuperscriptBox["x2", "2"], 
      RowBox[{"1", "+", 
       SuperscriptBox["x3", "2"]}]], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "x1", "]"}], "4"],
      SeriesData[$CellContext`x1, 0, {}, -1, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`x1, 
     0, {(1 + $CellContext`x3^2)^(-1), $CellContext`x2^2/(
      1 + $CellContext`x3^2)}, -1, 4, 1],
    Editable->False], ",", 
   InterpretationBox[
    RowBox[{
     FractionBox["1", "x1"], "-", 
     SuperscriptBox["x3", "2"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["x3", "4"]}], ")"}], " ", "x1"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["x3", "2"]}], "-", 
        SuperscriptBox["x3", "6"]}], ")"}], " ", 
      SuperscriptBox["x1", "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["x3", "4"], "+", 
        SuperscriptBox["x3", "8"]}], ")"}], " ", 
      SuperscriptBox["x1", "3"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "x1", "]"}], "4"],
      SeriesData[$CellContext`x1, 0, {}, -1, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`x1, 0, {
     1, -$CellContext`x3^2, 
      1 + $CellContext`x3^4, -$CellContext`x3^2 - $CellContext`x3^6, \
$CellContext`x3^4 + $CellContext`x3^8}, -1, 4, 1],
    Editable->False], ",", 
   InterpretationBox[
    RowBox[{"x1", "+", 
     RowBox[{
      SuperscriptBox["x2", "2"], " ", 
      SuperscriptBox["x1", "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["x2", "4"]}], ")"}], " ", 
      SuperscriptBox["x1", "3"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "x1", "]"}], "4"],
      SeriesData[$CellContext`x1, 0, {}, 1, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`x1, 0, {
     1, $CellContext`x2^2, -1 + $CellContext`x2^4}, 1, 4, 1],
    Editable->False], ",", 
   InterpretationBox[
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       SuperscriptBox["x3", "2"]]}], "-", 
     FractionBox["x1", 
      SuperscriptBox["x3", "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["x3", "4"]}], ")"}], " ", 
       SuperscriptBox["x1", "2"]}], 
      SuperscriptBox["x3", "6"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["x3", "4"]}], ")"}], " ", 
       SuperscriptBox["x1", "3"]}], 
      SuperscriptBox["x3", "8"]], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "x1", "]"}], "4"],
      SeriesData[$CellContext`x1, 0, {}, 0, 4, 1],
      Editable->False]}],
    SeriesData[$CellContext`x1, 
     0, {(-1) $CellContext`x3^(-2), (-1) $CellContext`x3^(-4), \
$CellContext`x3^(-6) (-1 + $CellContext`x3^4), $CellContext`x3^(-8) (-1 + \
$CellContext`x3^4)}, 0, 4, 1],
    Editable->False]}], "}"}]], "Output",
 CellChangeTimes->{3.843796789932605*^9, 3.8437969923129387`*^9, 
  3.843806060694957*^9},
 CellLabel->"Out[62]=",ExpressionUUID->"88bb0d4f-bb42-4dad-a341-2de97c6237f5"]
}, Open  ]],

Cell["\<\
Notice that, as mentioned, the coefficients of the Laurent expansion computed \
by g2 can be obtained without knowing the analytic expression of the output \
of g1.\
\>", "Text",ExpressionUUID->"1b96b928-330d-4571-88e2-401ebd99d262"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "See", " ", "more", " ", "application", " ", "of", " ", "SubGraph", " ", 
    "in", " ", "finiteflow"}], "-", "mathtools", "-", 
   RowBox[{
    RowBox[{"master", "/", "examples"}], "/", "linear_relations"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.843796832470848*^9, 
  3.8437969002851954`*^9}},ExpressionUUID->"fa103c22-a956-4104-a97a-\
9191d258193d"]
}, Open  ]]
},
WindowSize->{1853, 1025},
WindowMargins->{{0, Automatic}, {0, Automatic}},
FrontEndVersion->"12.0 for Linux x86 (64-bit) (2019\:5e744\:67088\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 195, 3, 50, "Input",ExpressionUUID->"7490795e-ec79-44d2-9339-659e8d43a0d4"],
Cell[756, 25, 722, 19, 82, "Code",ExpressionUUID->"bcee2109-f71d-4233-9a9e-5bda9910c36d",
 InitializationCell->False],
Cell[1481, 46, 199, 3, 31, "Input",ExpressionUUID->"c0578b51-ebbb-4009-82be-708e2ec17a4a"],
Cell[CellGroupData[{
Cell[1705, 53, 236, 4, 55, "Subsection",ExpressionUUID->"2a3fa6c6-1f27-4fb4-b7b6-30494f8e75f1"],
Cell[CellGroupData[{
Cell[1966, 61, 398, 9, 71, "Input",ExpressionUUID->"268a49d8-77f0-47be-a248-d0b7e494cd7d",
 InitializationCell->True],
Cell[2367, 72, 272, 4, 35, "Output",ExpressionUUID->"b415eae7-54a5-46b4-ac6b-b8e7677490a2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2676, 81, 467, 10, 71, "Input",ExpressionUUID->"8e7b7955-d527-43fc-b99d-df8debfaf9a0",
 InitializationCell->True],
Cell[3146, 93, 287, 5, 53, "Output",ExpressionUUID->"cb7f50d6-3734-414a-bd96-77029dace0f5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3470, 103, 649, 17, 94, "Input",ExpressionUUID->"7f020c5f-0b3d-4947-8e88-a140e07389a2",
 InitializationCell->True],
Cell[4122, 122, 275, 4, 35, "Output",ExpressionUUID->"2c63deba-646b-4349-af7f-64ef61561b62"],
Cell[4400, 128, 291, 5, 35, "Output",ExpressionUUID->"076d0061-4e65-4b50-b74b-9f7985a34436"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4728, 138, 524, 13, 94, "Input",ExpressionUUID->"949ead3e-7f9a-4453-87ce-783b883a4b19",
 InitializationCell->True],
Cell[5255, 153, 242, 3, 35, "Output",ExpressionUUID->"a4f5c735-688a-4249-9887-a52624183275"],
Cell[5500, 158, 243, 3, 35, "Output",ExpressionUUID->"2032d645-7b8a-4e76-aa7d-a277d6e74701"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5780, 166, 564, 14, 94, "Input",ExpressionUUID->"0aaf8bfe-4b67-4ffa-a507-f97b0410c882",
 InitializationCell->True],
Cell[6347, 182, 262, 3, 35, "Output",ExpressionUUID->"7699b955-bced-41ff-80dd-24b587c5d1a9"],
Cell[6612, 187, 270, 4, 53, "Output",ExpressionUUID->"07cb70d5-31cc-4edd-977e-d441bb621080"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6919, 196, 778, 21, 71, "Input",ExpressionUUID->"ce94372b-bef1-4547-ad8c-9841b3f22332",
 InitializationCell->True],
Cell[7700, 219, 732, 22, 54, "Output",ExpressionUUID->"b9d9604e-7466-4b6e-a492-8d461e81c672"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8469, 246, 733, 20, 76, "Code",ExpressionUUID->"b1dd84f9-6ef3-4eaa-9f0f-a2e94b594ddd"],
Cell[9205, 268, 776, 23, 54, "Output",ExpressionUUID->"507cd1cc-cdb1-4338-a502-f11ac0af7dea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10018, 296, 449, 12, 76, "Code",ExpressionUUID->"6af8ac29-21ce-4ba0-9528-faec624e66c1"],
Cell[10470, 310, 841, 27, 54, "Output",ExpressionUUID->"3dc9922a-37cb-49c2-9095-7bfc4cf05038"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11348, 342, 519, 11, 71, "Input",ExpressionUUID->"afc5e2a3-8e8c-4fd9-98bd-835ac38bbbe2",
 InitializationCell->True],
Cell[11870, 355, 26280, 582, 102, "Output",ExpressionUUID->"fe94655f-ca3a-40aa-a1bf-1276bef2b190"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38187, 942, 459, 10, 89, "Input",ExpressionUUID->"7568cb61-3ddc-4be1-9049-7271c7d016de",
 InitializationCell->True],
Cell[38649, 954, 1282, 22, 59, "Output",ExpressionUUID->"2bcf135a-993f-4619-8202-e8b50b6eb8f1"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[39980, 982, 161, 3, 55, "Subsection",ExpressionUUID->"f5bf0ffb-5bb0-43b8-9898-1ea06e9bbc74"],
Cell[CellGroupData[{
Cell[40166, 989, 307, 6, 76, "Code",ExpressionUUID->"8c4d53ce-3371-4382-acbd-6842e7b84292"],
Cell[40476, 997, 269, 4, 35, "Output",ExpressionUUID->"2603cbec-4d7b-4a22-9410-7fc28ad858cf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40782, 1006, 416, 9, 76, "Code",ExpressionUUID->"7fb5d1c7-f008-43e5-a4ce-7168a250b2b8"],
Cell[41201, 1017, 269, 4, 35, "Output",ExpressionUUID->"4f9cb801-41a0-45e7-b3dd-f1bf64175cd7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41507, 1026, 443, 10, 76, "Code",ExpressionUUID->"887c7388-5398-446a-af8e-04302199730d"],
Cell[41953, 1038, 347, 5, 35, "Output",ExpressionUUID->"71c33d3f-4a87-4358-b209-dfd0520a1195"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42337, 1048, 371, 8, 76, "Code",ExpressionUUID->"e7cf5298-6c65-4bce-bc53-2c55339c8deb"],
Cell[42711, 1058, 348, 5, 35, "Output",ExpressionUUID->"11eda697-e315-4060-9bee-74e423b93094"]
}, Open  ]],
Cell[43074, 1066, 533, 10, 31, "Input",ExpressionUUID->"2021dd90-2446-431a-a1f5-b48b02643c4d"],
Cell[CellGroupData[{
Cell[43632, 1080, 1048, 31, 98, "Code",ExpressionUUID->"78b0caee-0ceb-4d6e-96e9-3149d3d3ed94"],
Cell[44683, 1113, 247, 3, 35, "Output",ExpressionUUID->"ac340d23-8fbf-474f-a13e-4ebdfef2624f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44967, 1121, 441, 9, 55, "Input",ExpressionUUID->"99e3f974-2fbe-4d76-83bb-6c1e05e174cc"],
Cell[45411, 1132, 10802, 262, 102, "Output",ExpressionUUID->"1b6f1930-78e8-48fe-bb91-544b0cac65a1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56250, 1399, 1222, 37, 98, "Code",ExpressionUUID->"5565fd79-fb68-4aab-837c-449e9d26eef8"],
Cell[57475, 1438, 243, 3, 35, "Output",ExpressionUUID->"ef415d0f-b8ef-4d62-a994-2d6280fd6e41"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57755, 1446, 354, 8, 76, "Code",ExpressionUUID->"29bcb41a-fa7b-4807-bcce-5f6865961562"],
Cell[58112, 1456, 11415, 274, 102, "Output",ExpressionUUID->"bcd152b6-24c7-40d5-b310-bc38c99f470f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69564, 1735, 342, 7, 53, "Code",ExpressionUUID->"2f1f8c2b-ad6e-4093-ac3c-234d5c2ee6af"],
Cell[69909, 1744, 276, 4, 35, "Output",ExpressionUUID->"5508554a-83db-47cd-8686-38840fe953c9"]
}, Open  ]],
Cell[70200, 1751, 178, 3, 53, "Code",ExpressionUUID->"cbccdd42-db78-42e8-a6f3-c9d726aff822"],
Cell[CellGroupData[{
Cell[70403, 1758, 148, 2, 53, "Code",ExpressionUUID->"551c2d10-8e11-46a4-a14a-5987778691a1"],
Cell[70554, 1762, 1435, 27, 449, "Output",ExpressionUUID->"5dd36d63-ed6e-4f57-abfa-fd6bf8103ec0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72026, 1794, 479, 11, 76, "Code",ExpressionUUID->"bce0dd3a-b2bd-4200-8415-8d9dc2d69690"],
Cell[72508, 1807, 416, 8, 35, "Output",ExpressionUUID->"6ccebac9-631c-4e4c-9899-2f7a214e85cb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72961, 1820, 778, 18, 98, "Code",ExpressionUUID->"c082d7dd-f5c1-4287-b4b7-0d66369fa07b"],
Cell[73742, 1840, 765, 20, 65, "Output",ExpressionUUID->"abe2d188-443b-4b41-b768-efc0351885b3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74544, 1865, 646, 16, 76, "Code",ExpressionUUID->"c52b870d-7194-4de2-85f3-cfcce1494504"],
Cell[75193, 1883, 728, 18, 59, "Output",ExpressionUUID->"f73087f3-0fc4-4018-ba4c-dbe95b879524"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75958, 1906, 184, 3, 66, "Input",ExpressionUUID->"54a77de4-4c97-4406-91aa-748b7960408b",
 InitializationCell->True],
Cell[76145, 1911, 383, 7, 35, "Output",ExpressionUUID->"067e1ca4-bfda-4e19-b759-2f0e9fdef806"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76565, 1923, 599, 13, 71, "Input",ExpressionUUID->"be6675e8-cd01-493b-8d1a-6812e6ab04dd",
 InitializationCell->True],
Cell[77167, 1938, 8154, 196, 283, "Output",ExpressionUUID->"e26050b1-3789-4a7f-bce7-752a2469ce0c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[85358, 2139, 243, 5, 53, "Code",ExpressionUUID->"93a47f08-76fd-434b-9264-9ce8e5e01185"],
Cell[85604, 2146, 6008, 174, 206, "Output",ExpressionUUID->"2d617809-5371-4a04-b5fd-09a3701d70f1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91649, 2325, 254, 4, 66, "Input",ExpressionUUID->"0f72c7f7-538a-4cb9-aacf-d3b238d15314",
 InitializationCell->True],
Cell[91906, 2331, 801, 14, 35, "Output",ExpressionUUID->"31eddc80-7224-494b-9120-aa591af2fe71"]
}, Open  ]],
Cell[92722, 2348, 243, 4, 47, "Input",ExpressionUUID->"0375657c-8304-4d20-bcca-f7116be71230",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[93002, 2357, 211, 3, 55, "Subsection",ExpressionUUID->"965caeed-d183-49d5-8f27-ed566bbd2de9"],
Cell[CellGroupData[{
Cell[93238, 2364, 4323, 119, 191, "Input",ExpressionUUID->"70d1c491-9bbe-4313-b7e5-e24b8ea220ea",
 InitializationCell->True],
Cell[97564, 2485, 4353, 127, 115, "Output",ExpressionUUID->"eec33f38-bc64-4263-9cba-bb19a87af410"]
}, Open  ]],
Cell[101932, 2615, 448, 10, 76, "Code",ExpressionUUID->"0c1757c3-ca98-46e6-81c9-51d9f466e542"],
Cell[CellGroupData[{
Cell[102405, 2629, 608, 14, 89, "Input",ExpressionUUID->"1788ac1e-86d9-430a-9124-f703ae07a8ac",
 InitializationCell->True],
Cell[103016, 2645, 350, 8, 35, "Output",ExpressionUUID->"6757076f-4fa8-49e0-a845-0334be400970"]
}, Open  ]],
Cell[103381, 2656, 785, 17, 76, "Code",ExpressionUUID->"393ba01e-c90a-45fb-a77b-30b4a03ac1bd"],
Cell[104169, 2675, 814, 17, 76, "Code",ExpressionUUID->"3ab1a6b4-2563-4fac-9904-f865b5edc598"],
Cell[104986, 2694, 417, 7, 53, "Code",ExpressionUUID->"ce283ccb-7f69-443d-94e3-7489af92d403"],
Cell[CellGroupData[{
Cell[105428, 2705, 1056, 22, 76, "Code",ExpressionUUID->"57993f43-bc82-4e82-9709-966a7a4e50a0"],
Cell[106487, 2729, 571, 14, 35, "Output",ExpressionUUID->"be4beac3-53bf-47e4-a6a7-2c7d5a4b55ea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107095, 2748, 306, 6, 53, "Code",ExpressionUUID->"9c80d89c-1ac4-4b60-a40d-9155899c9521"],
Cell[107404, 2756, 16607, 480, 433, "Output",ExpressionUUID->"dc804e11-a56d-4249-bf6f-181da3ea61c0"]
}, Open  ]],
Cell[124026, 3239, 150, 2, 53, "Code",ExpressionUUID->"e1946354-dc73-46e7-b1fe-fc661207ae52"]
}, Open  ]],
Cell[CellGroupData[{
Cell[124213, 3246, 132, 3, 55, "Subsection",ExpressionUUID->"91c513ea-1b2f-4335-8c2a-43b0348e6102"],
Cell[124348, 3251, 252, 6, 31, "Input",ExpressionUUID->"20c04dc9-9070-442d-9164-22294180eb99"],
Cell[124603, 3259, 193, 3, 36, "Text",ExpressionUUID->"926c0cb7-bc06-495d-a2c0-fffbe161a48b"],
Cell[124799, 3264, 311, 5, 36, "Text",ExpressionUUID->"6f21ef10-9248-47b2-bc8c-854aa2e33967"],
Cell[CellGroupData[{
Cell[125135, 3273, 1673, 51, 142, "Code",ExpressionUUID->"262433be-afb8-4b0e-8cfc-47c661420234"],
Cell[126811, 3326, 203, 3, 35, "Output",ExpressionUUID->"df6c6037-0bc5-4e16-bd94-ef3eb781f774"],
Cell[127017, 3331, 203, 3, 35, "Output",ExpressionUUID->"aa037541-f76b-4431-93aa-7ec26507b0b1"]
}, Open  ]],
Cell[127235, 3337, 327, 5, 36, "Text",ExpressionUUID->"736039d9-1fe2-47a5-bec7-7be1b0846722"],
Cell[CellGroupData[{
Cell[127587, 3346, 131, 2, 53, "Code",ExpressionUUID->"64bef1af-bece-4126-8a30-dea8d6b17423"],
Cell[127721, 3350, 197, 3, 35, "Output",ExpressionUUID->"fce20ed7-1e10-465b-8cff-24d0eefdbdc1"]
}, Open  ]],
Cell[127933, 3356, 163, 3, 36, "Text",ExpressionUUID->"a4ce4c3b-e5ed-469c-b213-f3976cd12d95"],
Cell[CellGroupData[{
Cell[128121, 3363, 230, 5, 53, "Code",ExpressionUUID->"6661428e-9a3f-4056-b9c3-923cd8afcd78"],
Cell[128354, 3370, 201, 3, 35, "Output",ExpressionUUID->"902343cd-e2ba-4c3a-932c-f322f71af35e"]
}, Open  ]],
Cell[128570, 3376, 191, 3, 36, "Text",ExpressionUUID->"59e22b11-d8d6-4e7b-b185-2ce3c8b17dd7"],
Cell[CellGroupData[{
Cell[128786, 3383, 236, 4, 53, "Code",ExpressionUUID->"383f7ef5-703f-4d0c-b16b-7509bbb84d6e"],
Cell[129025, 3389, 199, 3, 35, "Output",ExpressionUUID->"0ed98ed1-9b67-462d-8f7e-827aa4d189b4"]
}, Open  ]],
Cell[129239, 3395, 174, 3, 53, "Code",ExpressionUUID->"fe8bc84c-9722-4eea-9b5e-342e707c6864"],
Cell[129416, 3400, 209, 3, 36, "Text",ExpressionUUID->"a5fb657a-9e80-4f8b-9148-3ebf7822539e"],
Cell[CellGroupData[{
Cell[129650, 3407, 212, 3, 31, "Input",ExpressionUUID->"09d526ac-74a7-4dcd-a1eb-d71373cfbb73"],
Cell[129865, 3412, 673, 13, 449, "Output",ExpressionUUID->"17fb4baf-2283-4895-87e2-df407bbb96fe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[130575, 3430, 210, 3, 31, "Input",ExpressionUUID->"225b0fc6-5ee1-4b69-ab7b-e7885aae12d6"],
Cell[130788, 3435, 675, 13, 449, "Output",ExpressionUUID->"76cecc1d-1335-4dfe-a9df-661dbdd7c699"]
}, Open  ]],
Cell[CellGroupData[{
Cell[131500, 3453, 190, 3, 53, "Code",ExpressionUUID->"456ff4e7-2851-49f0-b8c7-c8fe8946d110"],
Cell[131693, 3458, 445, 11, 35, "Output",ExpressionUUID->"100cfe13-026b-41f6-a22d-58bdd188dab7"]
}, Open  ]],
Cell[132153, 3472, 172, 3, 36, "Text",ExpressionUUID->"ac568cfe-d7d8-4436-a353-8322926d8405"],
Cell[CellGroupData[{
Cell[132350, 3479, 281, 6, 53, "Code",ExpressionUUID->"391fbc11-a5a1-4158-9d4b-daf2e777922e"],
Cell[132634, 3487, 937, 21, 35, "Output",ExpressionUUID->"f5ee59b7-94af-4cca-8dca-2a34c7741c3b"]
}, Open  ]],
Cell[133586, 3511, 236, 6, 36, "Text",ExpressionUUID->"68218cb9-b661-4010-8bd5-2f7c772dcda4"],
Cell[CellGroupData[{
Cell[133847, 3521, 199, 3, 53, "Code",ExpressionUUID->"ffd36146-c460-41d3-8f1f-7e39b75e9dcf"],
Cell[134049, 3526, 3210, 96, 85, "Output",ExpressionUUID->"b36ec1c9-206f-451d-ae7a-af37296733e8"]
}, Open  ]],
Cell[137274, 3625, 171, 3, 36, "Text",ExpressionUUID->"f2464fa8-0227-4f91-bb40-39e3fa9de59a"],
Cell[CellGroupData[{
Cell[137470, 3632, 265, 6, 53, "Code",ExpressionUUID->"fb3e9e3f-5548-45b3-a148-97dd817c485c"],
Cell[137738, 3640, 1329, 44, 59, "Output",ExpressionUUID->"d678e14c-28b8-4464-a832-991ab6edf59f"]
}, Open  ]],
Cell[139082, 3687, 202, 3, 36, "Text",ExpressionUUID->"fe8d129f-8f33-42df-b3af-b2ce2658aefe"],
Cell[CellGroupData[{
Cell[139309, 3694, 200, 3, 53, "Code",ExpressionUUID->"c4aa51eb-cef7-468f-b573-cf739901b602"],
Cell[139512, 3699, 3525, 108, 66, "Output",ExpressionUUID->"88bb0d4f-bb42-4dad-a341-2de97c6237f5"]
}, Open  ]],
Cell[143052, 3810, 243, 4, 36, "Text",ExpressionUUID->"1b96b928-330d-4571-88e2-401ebd99d262"],
Cell[143298, 3816, 415, 11, 31, "Input",ExpressionUUID->"fa103c22-a956-4104-a97a-9191d258193d"]
}, Open  ]]
}
]
*)

